Package: ASURAT
Type: Package
Title: Functional annotation-driven unsupervised clustering for
        single-cell data
Version: 1.14.0
Authors@R: c(person("Keita", "Iida", email = "kiida@protein.osaka-u.ac.jp",
             role = c("aut", "cre"),
             comment = c(ORCID = "0000-0002-1076-830X")),
             person("Johannes Nicolaus", "Wibisana",
                    email = "nico@protein.osaka-u.ac.jp", role = c("ctb")))
Description: ASURAT is a software for single-cell data analysis.
    Using ASURAT, one can simultaneously perform unsupervised clustering and
    biological interpretation in terms of cell type, disease, biological process,
    and signaling pathway activity. Inputting a single-cell RNA-seq data and
    knowledge-based databases, such as Cell Ontology, Gene Ontology, KEGG, etc.,
    ASURAT transforms gene expression tables into original multivariate tables,
    termed sign-by-sample matrices (SSMs).
License: GPL-3 + file LICENSE
biocViews: GeneExpression, SingleCell, Sequencing, Clustering,
        GeneSignaling
VignetteBuilder: knitr
Encoding: UTF-8
LazyData: TRUE
Depends: R (>= 4.0.0)
Imports: SingleCellExperiment, SummarizedExperiment, S4Vectors, Rcpp
        (>= 1.0.7), cluster, utils, plot3D, ComplexHeatmap, circlize,
        grid, grDevices, graphics
Suggests: ggplot2, TENxPBMCData, dplyr, Rtsne, Seurat, AnnotationDbi,
        BiocGenerics, stringr, org.Hs.eg.db, knitr, rmarkdown, testthat
        (>= 3.0.0)
RoxygenNote: 7.1.2
LinkingTo: Rcpp
Config/testthat/edition: 3
git_url: https://git.bioconductor.org/packages/ASURAT
git_branch: RELEASE_3_22
git_last_commit: 9212396
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.22
Date/Publication: 2025-10-30
NeedsCompilation: yes
Packaged: 2025-10-30 20:29:13 UTC; biocbuild
Author: Keita Iida [aut, cre] (ORCID: <https://orcid.org/0000-0002-1076-830X>),
  Johannes Nicolaus Wibisana [ctb]
Maintainer: Keita Iida <kiida@protein.osaka-u.ac.jp>

# ASURAT
## Brief introduction
ASURAT is a computational pipeline, implemented in the R programming language, for single-cell transcriptomics.
Using ASURAT, one can simultaneously perform unsupervised clustering and biological interpretation in terms of cell type, disease, biological process, and signaling pathway activity.

## Graphical abstract
<img src="vignettes/figure_00_0001.png" width="500px">

## Vignettes
Well-documented vignette and tutorial is available from the following URL:

* https://keita-iida.github.io/ASURAT/

## Installation
One can install ASURAT by the following code:

```{r}
devtools::install_github("keita-iida/ASURAT", upgrade = "never")
```

## Preprint
The latest version is available from the following bioRxiv page:

* https://www.biorxiv.org/content/10.1101/2021.06.09.447731v3

## License
[GPL-3](https://github.com/keita-iida/ASURAT/blob/main/LICENSE)

#-----------------------------------------------------------------------------80
#
#-----------------------------------------------------------------------------80
#' Remove signs including too few or too many genes.
#'
#' This function removes signs including too few or too many genes.
#'
#' @param sce A SingleCellExperiment object.
#' @param min_ngenes Minimum number of genes, which must be greater than one.
#' @param max_ngenes Maximum number of genes, which must be greater than one.
#'
#' @return A SingleCellExperiment object.
#' @import SingleCellExperiment
#' @import SummarizedExperiment
#' @import S4Vectors
#' @export
#'
#' @examples
#' data(pbmc_eg)
#' data(human_GO_eg)
#' pbmcs <- list(GO = pbmc_eg)
#' S4Vectors::metadata(pbmcs$GO) <- list(sign = human_GO_eg[["BP"]])
#' pbmcs$GO <- remove_signs(sce = pbmcs$GO, min_ngenes = 2, max_ngenes = 1000)
#' # The results are stored in `metadata(pbmcs$GO)$sign`.
#'
remove_signs <- function(sce = NULL, min_ngenes = 2, max_ngenes = 1000){
  #--------------------------------------------------
  # Error handling
  #--------------------------------------------------
  if(is.null(metadata(sce)$sign)){
    stop("metadata(sce)$sign must have a database.")
  }
  if(min_ngenes <= 1){ stop("min_ngenes should be >= 2.") }
  if(max_ngenes <= 1){ stop("max_ngenes should be >= 2.") }
  #--------------------------------------------------
  # Select innate genes.
  #--------------------------------------------------
  innate_g <- data.frame(gene = rownames(sce), geneID = rowData(sce)$geneID)
  tmp <- metadata(sce)$sign
  for(i in seq_len(nrow(tmp))){
    #------------------------------
    # GeneID: ENTREZ Gene ID
    #------------------------------
    geneIDs <- unlist(strsplit(tmp$GeneID[i], "/"))
    geneIDs <- geneIDs[which(geneIDs %in% innate_g$geneID)]
    tmp$GeneID[i] <- paste(geneIDs, collapse = "/")
    #------------------------------
    # Gene: gene symbol
    #------------------------------
    genes <- c()
    for(j in seq_len(length(geneIDs))){
      genes <- c(genes, innate_g[which(innate_g$geneID == geneIDs[j]), ]$gene)
    }
    tmp$Gene[i] <- paste(genes, collapse = "/")
    #------------------------------
    # Count
    #------------------------------
    tmp$Count[i] <- as.integer(length(geneIDs))
  }
  metadata(sce)$sign <- tmp
  #--------------------------------------------------
  # Remove IDs including too few or too many genes.
  #--------------------------------------------------
  tmp <- metadata(sce)$sign
  res <- tmp[which((tmp$Count >= min_ngenes) & (tmp$Count <= max_ngenes)), ]
  rownames(res) <- seq_len(nrow(res))
  metadata(sce)$sign <- as.data.frame(res)

  return(sce)
}
#-----------------------------------------------------------------------------80
#
#-----------------------------------------------------------------------------80
#' Cluster each functional gene set into three groups.
#'
#' This function clusters each functional gene set into strongly, variably, and
#'   weakly correlated gene sets.
#'
#' @param sce A SingleCellExperiment object.
#' @param cormat A correlation matrix of gene expressions.
#' @param th_posi A threshold of positive correlation coefficient.
#' @param th_nega A threshold of negative correlation coefficient.
#'
#' @return A SingleCellExperiment object.
#' @import SingleCellExperiment
#' @import SummarizedExperiment
#' @import S4Vectors
#' @importFrom cluster pam
#' @export
#'
#' @examples
#' data(pbmc_eg)
#' data(human_GO_eg)
#' mat <- t(as.matrix(SummarizedExperiment::assay(pbmc_eg, "centered")))
#' pbmc_cormat <- cor(mat, method = "spearman")
#' pbmcs <- list(GO = pbmc_eg)
#' S4Vectors::metadata(pbmcs$GO) <- list(sign = human_GO_eg[["BP"]])
#' pbmcs$GO <- remove_signs(sce = pbmcs$GO, min_ngenes = 2, max_ngenes = 1000)
#' pbmcs$GO <- cluster_genesets(sce = pbmcs$GO, cormat = pbmc_cormat,
#'                              th_posi = 0.24, th_nega = -0.20)
#' # The results are stored in `metadata(pbmcs$GO)$sign`.
#'
cluster_genesets <- function(
  sce = NULL, cormat = NULL, th_posi = NULL, th_nega = NULL
){
  #--------------------------------------------------
  # Error handling
  #--------------------------------------------------
  if(th_posi < 0){ stop("th_posi should be >= 0.") }
  if(th_nega > 0){ stop("th_nega should be <= 0.") }
  #--------------------------------------------------
  # Correlation graph-based decomposition of FGSs
  #--------------------------------------------------
  df <- metadata(sce)$sign
  res <- c("SignID", "Description", "IC",
           "CountStrgCorrGene", "CountVariCorrGene", "CountWeakCorrGene",
           "CorrStrg", "CorrVari", "CorrWeak",
           "StrgCorrGene", "VariCorrGene", "WeakCorrGene",
           "StrgCorrGeneID", "VariCorrGeneID", "WeakCorrGeneID")
  res <- data.frame(matrix(ncol = 15, nrow = 0, dimnames = list(NULL, res)))
  for(i in seq_len(nrow(df))){
    genes <- unlist(strsplit(df$Gene[i], "/"))
    if(length(genes) <= 1){
      next
    }
    inds <- which(rownames(cormat) %in% genes)
    if(length(inds) <= 2){
      next
    }
    mat <- cormat[inds, inds]
    #--------------------------------------------------
    # Select genes having strong correlations with others.
    #--------------------------------------------------
    diag(mat) <- -99
    inds_posi <- which(apply(mat, 2, function(x) sum(x >= th_posi)) > 0)
    diag(mat) <- 99
    inds_nega <- which(apply(mat, 2, function(x) sum(x <= th_nega)) > 0)
      
    if(length(inds_posi) == 0){
      #--------------------------------------------------
      # Define strongly, variably, and weakly correlated gene sets.
      #--------------------------------------------------
      genes_strg <- NA ; genes_vari <- NA ; genes_weak <- genes
      mean_strg <- NA ; mean_vari <- NA
      mean_weak <- ifelse(length(genes_weak) <= 1, NA, mean(mat[mat <= 1]))
    }else{
      if(length(inds_nega) == 0){
        #--------------------------------------------------
        # Define strongly, variably, and weakly correlated gene sets.
        #--------------------------------------------------
        genes_vari <- NA ; mean_vari <- NA
          
        submat <- mat[inds_posi, inds_posi]
        genes_strg <- rownames(submat)
        mean_strg <- ifelse(length(genes_strg) <= 1, NA,
                            mean(submat[submat <= 1]))
        if(mean_strg < th_posi){
          genes_strg <- NA ; mean_strg <- NA
          genes_weak <- genes
          mean_weak <- ifelse(length(genes_weak) <= 1, NA, mean(mat[mat <= 1]))
        }else{
          genes_weak <- setdiff(genes, genes_strg)  
          inds <- which(rownames(mat) %in% genes_weak)
          tmp <- mat[inds, inds]
          mean_weak <- ifelse(length(inds) <= 1, NA, mean(tmp[tmp <= 1]))
        }
      }else{
        inds <- union(inds_posi, inds_nega)
        submat <- mat[inds, inds] ; diag(submat) <- 1
        #--------------------------------------------------
        # PAM clustering using cluster package
        #--------------------------------------------------
        c <- pam(submat, k = 2)
        diag(submat) <- 99
        gset <- list() ; mu <- c()
        for(j in seq_len(2)){
          gset[[j]] <- names(c[["clustering"]])[which(c[["clustering"]] == j)]
          inds <- which(rownames(submat) %in% gset[[j]])
          tmp <- submat[inds, inds]
          mu[j] <- ifelse(length(inds) <= 1, NA, mean(tmp[tmp <= 1]))
        }
        #--------------------------------------------------
        # Define strongly, variably, and weakly correlated gene sets.
        #--------------------------------------------------
        inds <- order(mu, decreasing = TRUE)
        genes_strg <- gset[[inds[1]]]
        mean_strg <- mu[inds[1]]
        if(mean_strg < th_posi){
          genes_strg <- NA ; mean_strg <- NA
          genes_vari <- NA ; mean_vari <- NA
          genes_weak <- genes
          mean_weak <- ifelse(length(genes_weak) <= 1, NA, mean(mat[mat <= 1]))
        }else{
          genes_vari <- gset[[inds[2]]]
          mean_vari <- mu[inds[2]]
          genes_weak <- setdiff(genes, union(gset[[1]], gset[[2]]))  
          inds <- which(rownames(mat) %in% genes_weak)
          tmp <- mat[inds, inds]
          mean_weak <- ifelse(length(inds) <= 1, NA, mean(tmp[tmp <= 1]))
        }
      }
    }
    #--------------------------------------------------
    # Result
    #--------------------------------------------------
    tmp <- as.data.frame(rowData(sce))
    if(is.element(NA, genes_strg)){
      genes_strg <- NA ; geneIDs_strg <- NA ; count_strg <- 0
    }else{
      count_strg <- length(genes_strg)
      gs <- c()
      for(j in seq_along(genes_strg)){
        inds <- which(rownames(tmp) == genes_strg[j])
        if(ncol(tmp) == 1){
          if(colnames(tmp) == "geneID"){
            gs <- c(gs, tmp[inds, ])
          }else{
            stop("rowData() has only one column; the name must be \"geneID\".")
          }
        }else{
          gs <- c(gs, tmp[inds, ]$geneID)
        }
      }
      geneIDs_strg <- paste(gs, collapse = "/")
      genes_strg <- paste(genes_strg, collapse = "/")
    }
    if(is.element(NA, genes_vari)){
      genes_vari <- NA ; geneIDs_vari <- NA ; count_vari <- 0
    }else{
      count_vari <- length(genes_vari)
      gs <- c()
      for(j in seq_along(genes_vari)){
        inds <- which(rownames(tmp) == genes_vari[j])
        if(ncol(tmp) == 1){
          if(colnames(tmp) == "geneID"){
            gs <- c(gs, tmp[inds, ])
          }else{
            stop("rowData() has only one column; the name must be \"geneID\".")
          }
        }else{
          gs <- c(gs, tmp[inds, ]$geneID)
        }
      }
      geneIDs_vari <- paste(gs, collapse = "/")
      genes_vari <- paste(genes_vari, collapse = "/")
    }
    if(is.element(NA, genes_weak)){
      genes_weak <- NA ; geneIDs_weak <- NA ; count_weak <- 0
    }else{
      count_weak <- length(genes_weak)
      gs <- c()
      for(j in seq_along(genes_weak)){
        inds <- which(rownames(tmp) == genes_weak[j])
        if(ncol(tmp) == 1){
          if(colnames(tmp) == "geneID"){
            gs <- c(gs, tmp[inds, ])
          }else{
            stop("rowData() has only one column; the name must be \"geneID\".")
          }
        }else{
          gs <- c(gs, tmp[inds, ]$geneID)
        }
      }
      geneIDs_weak <- paste(gs, collapse = "/")
      genes_weak <- paste(genes_weak, collapse = "/")
    }
    dg <- data.frame(SignID = df$ID[i], Description = df$Description[i],
                     IC = df$IC[i],
                     CountStrgCorrGene = count_strg,
                     CountVariCorrGene = count_vari,
                     CountWeakCorrGene = count_weak,
                     CorrStrg = mean_strg,
                     CorrVari = mean_vari,
                     CorrWeak = mean_weak,
                     StrgCorrGene = genes_strg,
                     VariCorrGene = genes_vari,
                     WeakCorrGene = genes_weak,
                     StrgCorrGeneID = geneIDs_strg,
                     VariCorrGeneID = geneIDs_vari,
                     WeakCorrGeneID = geneIDs_weak)
    res <- rbind(res, dg)
  }
  metadata(sce)$sign <- res

  return(sce)
}
#-----------------------------------------------------------------------------80
#
#-----------------------------------------------------------------------------80
#' Define signs for strongly and variably correlated gene sets.
#'
#' This function define signs for strongly and variably correlated gene sets.
#'
#' @param sce A SingleCellExperiment object.
#' @param min_cnt_strg An integer for the cutoff value for strongly correlated
#'   gene sets.
#' @param min_cnt_vari An integer for the cutoff value for variably correlated
#'   gene sets.
#'
#' @return A SingleCellExperiment object.
#' @import SingleCellExperiment
#' @import SummarizedExperiment
#' @import S4Vectors
#' @export
#'
#' @examples
#' data(pbmc_eg)
#' data(human_GO_eg)
#' mat <- t(as.matrix(SummarizedExperiment::assay(pbmc_eg, "centered")))
#' pbmc_cormat <- cor(mat, method = "spearman")
#' pbmcs <- list(GO = pbmc_eg)
#' S4Vectors::metadata(pbmcs$GO) <- list(sign = human_GO_eg[["BP"]])
#' pbmcs$GO <- remove_signs(sce = pbmcs$GO, min_ngenes = 2, max_ngenes = 1000)
#' pbmcs$GO <- cluster_genesets(sce = pbmcs$GO, cormat = pbmc_cormat,
#'                              th_posi = 0.24, th_nega = -0.20)
#' pbmcs$GO <- create_signs(sce = pbmcs$GO, min_cnt_strg = 2, min_cnt_vari = 2)
#' # The results are stored in `metadata(pbmcs$GO)$sign_all`.
#'
create_signs <- function(sce = NULL, min_cnt_strg = 2, min_cnt_vari = 2){
  #--------------------------------------------------
  # Error handling
  #--------------------------------------------------
  if(min_cnt_strg <= 0){ stop("min_cnt_strg should be >= 1.") }
  if(min_cnt_vari <= 0){ stop("min_cnt_vari should be >= 1.") }

  df <- metadata(sce)$sign
  #--------------------------------------------------
  # Strongly correlated gene sets
  #--------------------------------------------------
  df_strg <- df[which(df$CountStrgCorrGene >= min_cnt_strg), ]
  if(nrow(df_strg) >= 1){
    df_strg <- data.frame(
      SignID = df_strg$SignID, Description = df_strg$Description,
      IC = df_strg$IC,
      CountStrgCorrGene = df_strg$CountStrgCorrGene,
      CountWeakCorrGene = df_strg$CountWeakCorrGene,
      CorrStrg = df_strg$CorrStrg, CorrWeak = df_strg$CorrWeak,
      StrgCorrGene = df_strg$StrgCorrGene, WeakCorrGene = df_strg$WeakCorrGene,
      StrgCorrGeneID = df_strg$StrgCorrGeneID,
      WeakCorrGeneID = df_strg$WeakCorrGeneID)
  }
  #--------------------------------------------------
  # Variably correlated gene sets
  #--------------------------------------------------
  df_vari <- df[which(df$CountVariCorrGene >= min_cnt_vari), ]
  if(nrow(df_vari) >= 1){
    df_vari <- data.frame(
      SignID = df_vari$SignID, Description = df_vari$Description,
      IC = df_vari$IC,
      CountVariCorrGene = df_vari$CountVariCorrGene,
      CountWeakCorrGene = df_vari$CountWeakCorrGene,
      CorrVari = df_vari$CorrVari, CorrWeak = df_vari$CorrWeak,
      VariCorrGene = df_vari$VariCorrGene, WeakCorrGene = df_vari$WeakCorrGene,
      VariCorrGeneID = df_vari$VariCorrGeneID,
      WeakCorrGeneID = df_vari$WeakCorrGeneID)
  }
  #--------------------------------------------------
  # Store the results.
  #--------------------------------------------------
  metadata(sce)$sign_SCG <- df_strg
  metadata(sce)$sign_VCG <- df_vari
  #--------------------------------------------------
  # Add metadata(sce)$sign_all.
  #--------------------------------------------------
  metadata(sce)$sign <- NULL
  tmp <- c("SignID", "Description", "IC",
           "CountCorrGene", "CountWeakCorrGene", "Corr", "CorrWeak",
           "CorrGene", "WeakCorrGene", "CorrGeneID", "WeakCorrGeneID")
  colnames(df_strg) <- tmp
  colnames(df_vari) <- tmp
  if(nrow(df_strg) == 0){
    stop("SCG is not defined.")
  }else{
    if(nrow(df_vari) == 0){
      metadata(sce)$sign_all <- cbind(CorrType = "SCG", df_strg)
    }else{
      metadata(sce)$sign_all <- rbind(cbind(CorrType = "SCG", df_strg),
                                      cbind(CorrType = "VCG", df_vari))
    }
  }

  return(sce)
}
#-----------------------------------------------------------------------------80
#
#-----------------------------------------------------------------------------80
#' Remove redundant signs using semantic similarity matrices.
#'
#' This function removes redundant signs using semantic similarity matrices.
#'
#' @param sce A SingleCellExperiment object.
#' @param similarity_matrix A semantic similarity matrix.
#' @param threshold A threshold value of semantic similarity, used for
#'   regarding biological terms as similar ones 
#' @param keep_rareID If TRUE, biological terms with the larger ICs are kept.
#'
#' @return A SingleCellExperiment object.
#' @import SingleCellExperiment
#' @import SummarizedExperiment
#' @import S4Vectors
#' @export
#'
#' @examples
#' data(pbmc_eg)
#' data(human_GO_eg)
#' mat <- t(as.matrix(SummarizedExperiment::assay(pbmc_eg, "centered")))
#' pbmc_cormat <- cor(mat, method = "spearman")
#' pbmcs <- list(GO = pbmc_eg)
#' S4Vectors::metadata(pbmcs$GO) <- list(sign = human_GO_eg[["BP"]])
#' pbmcs$GO <- remove_signs(sce = pbmcs$GO, min_ngenes = 2, max_ngenes = 1000)
#' pbmcs$GO <- cluster_genesets(sce = pbmcs$GO, cormat = pbmc_cormat,
#'                              th_posi = 0.24, th_nega = -0.20)
#' pbmcs$GO <- create_signs(sce = pbmcs$GO, min_cnt_strg = 2, min_cnt_vari = 2)
#' pbmcs$GO <- remove_signs_redundant(
#'   sce = pbmcs$GO, similarity_matrix = human_GO_eg$similarity_matrix$BP,
#'   threshold = 0.80, keep_rareID = TRUE)
#' # The results are stored in `metadata(pbmcs$GO)$sign_SCG`,
#' # `metadata(pbmcs$GO)$sign_VCG`, `metadata(pbmcs$GO)$sign_all`,
#' # and if there exist, `metadata(pbmcs$GO)$sign_SCG_redundant` and
#' # `metadata(pbmcs$GO)$sign_VCG_redundant`.
#'
remove_signs_redundant <- function(
  sce = NULL, similarity_matrix = NULL, threshold = NULL, keep_rareID = NULL
){
  #--------------------------------------------------
  # Error handling
  #--------------------------------------------------
  if(is.null(similarity_matrix)){
    stop("Semantic similarity is not defined. Skip this process.")
  }

  report <- list()
  s_or_v <- c("sign_SCG", "sign_VCG")
  for(k in seq_along(s_or_v)){
    #--------------------------------------------------
    # Report format
    #--------------------------------------------------
    df <- metadata(sce)[[s_or_v[k]]]
    if(nrow(df) == 0){
      next
    }
    inds <- which(rownames(similarity_matrix) %in% df$SignID)
    if(length(inds) < 2){
      next
    }
    submat <- similarity_matrix[inds, inds]
    inds <- order(df$IC, decreasing = FALSE)
    submat <- submat[inds, inds]
    report[[k]] <- c("Similarity", "Kept_SignID", "Removed_SignID",
                     "Kept_Description", "Removed_Description",
                     "Kept_GeneCount", "Removed_GeneCount",
                     "Kept_Gene", "Removed_Gene", "Kept_IC", "Removed_IC")
    report[[k]] <- data.frame(matrix(ncol = 11, nrow = 0,
                                     dimnames = list(NULL, report[[k]])))
    flag <- rep(0, dim(submat)[1])
    if(keep_rareID == TRUE){
      #--------------------------------------------------
      # case I
      #--------------------------------------------------
      I <- dim(submat)[1]
      for(i in seq(I, 2)){
        J <- dim(submat)[2] - (I - i + 1) # Be careful
        if(flag[i] == 1){                 # Be careful
          next
        }
        for(j in seq_len(J)){
          if(is.na(submat[i, j])){
            next
          }
          if(abs(submat[i, j]) >= threshold){
            ind_kept <- which(df$SignID == rownames(submat)[i])
            ind_remo <- which(df$SignID == rownames(submat)[j])
            if(k == 1){
              kept_count <- df[ind_kept, ]$CountStrgCorrGene +
                            df[ind_kept, ]$CountWeakCorrGene
              remo_count <- df[ind_remo, ]$CountStrgCorrGene +
                            df[ind_remo, ]$CountWeakCorrGene
              kept_genes <- paste(df[ind_kept, ]$StrgCorrGene,
                                  df[ind_kept, ]$WeakCorrGene, sep = "/")
              remo_genes <- paste(df[ind_remo, ]$StrgCorrGene,
                                  df[ind_remo, ]$WeakCorrGene, sep = "/")
            }else if(k == 2){
              kept_count <- df[ind_kept, ]$CountVariCorrGene +
                            df[ind_kept, ]$CountWeakCorrGene
              remo_count <- df[ind_remo, ]$CountVariCorrGene +
                            df[ind_remo, ]$CountWeakCorrGene
              kept_genes <- paste(df[ind_kept, ]$VariCorrGene,
                                  df[ind_kept, ]$WeakCorrGene, sep = "/")
              remo_genes <- paste(df[ind_remo, ]$VariCorrGene,
                                  df[ind_remo, ]$WeakCorrGene, sep = "/")
            }
            report[[k]] <- rbind(report[[k]], data.frame(
              Similarity = submat[i, j],
              Kept_SignID = df[ind_kept, ]$SignID,
              Removed_SignID = df[ind_remo, ]$SignID,
              Kept_Description = df[ind_kept, ]$Description,
              Removed_Description = df[ind_remo, ]$Description,
              Kept_GeneCount = kept_count,
              Removed_GeneCount = remo_count,
              Kept_Gene = kept_genes,
              Removed_Gene = remo_genes,
              Kept_IC = df[ind_kept, ]$IC,
              Removed_IC = df[ind_remo, ]$IC
            ))
            flag[j] <- 1
          }
        }
      }
    }else{
      #--------------------------------------------------
      # case II
      #--------------------------------------------------
      I <- dim(submat)[1] - 1
      J <- dim(submat)[2]
      for(i in seq_len(I)){
        j0 <- i + 1       # Be careful
        if(flag[i] == 1){ # Be careful
          next
        }
        for(j in seq(j0, J)){
          if(is.na(submat[i, j])){
            next
          }
          if(abs(submat[i, j]) >= threshold){
            ind_kept <- which(df$SignID == rownames(submat)[i])
            ind_remo <- which(df$SignID == rownames(submat)[j])
            if(k == 1){
              kept_count <- df[ind_kept, ]$CountStrgCorrGene +
                            df[ind_kept, ]$CountWeakCorrGene
              remo_count <- df[ind_remo, ]$CountStrgCorrGene +
                            df[ind_remo, ]$CountWeakCorrGene
              kept_genes <- paste(df[ind_kept, ]$StrgCorrGene,
                                  df[ind_kept, ]$WeakCorrGene, sep = "/")
              remo_genes <- paste(df[ind_remo, ]$StrgCorrGene,
                                  df[ind_remo, ]$WeakCorrGene, sep = "/")
            }else if(k == 2){
              kept_count <- df[ind_kept, ]$CountVariCorrGene +
                            df[ind_kept, ]$CountWeakCorrGene
              remo_count <- df[ind_remo, ]$CountVariCorrGene +
                            df[ind_remo, ]$CountWeakCorrGene
              kept_genes <- paste(df[ind_kept, ]$VariCorrGene,
                                  df[ind_kept, ]$WeakCorrGene, sep = "/")
              remo_genes <- paste(df[ind_remo, ]$VariCorrGene,
                                  df[ind_remo, ]$WeakCorrGene, sep = "/")
            }
            report[[k]] <- rbind(report[[k]], data.frame(
              Similarity = submat[i, j],
              Kept_SignID = df[ind_kept, ]$SignID,
              Removed_SignID = df[ind_remo, ]$SignID,
              Kept_Description = df[ind_kept, ]$Description,
              Removed_Description = df[ind_remo, ]$Description,
              Kept_GeneCount = kept_count,
              Removed_GeneCount = remo_count,
              Kept_Gene = kept_genes,
              Removed_Gene = remo_genes,
              Kept_IC = df[ind_kept, ]$IC,
              Removed_IC = df[ind_remo, ]$IC
            ))
            flag[j] <- 1
          }
        }
      }
    }
    #--------------------------------------------------
    # Remove redundant signs.
    #--------------------------------------------------
    if(length(report[[k]]$Removed_SignID) >= 1){
      kept_IDs <- setdiff(df$SignID, report[[k]]$Removed_SignID)
      res <- df[which(df$SignID %in% kept_IDs), ]
      rownames(res) <- seq_len(nrow(res))
    }else{
      res <- df
    }
    metadata(sce)[[s_or_v[k]]] <- res
  }
  #--------------------------------------------------
  # Modify metadata(sce)$sign_all.
  #--------------------------------------------------
  df_strg <- as.data.frame(metadata(sce)$sign_SCG)
  df_vari <- as.data.frame(metadata(sce)$sign_VCG)
  tmp <- c("SignID", "Description", "IC",
           "CountCorrGene", "CountWeakCorrGene", "Corr", "CorrWeak",
           "CorrGene", "WeakCorrGene", "CorrGeneID", "WeakCorrGeneID")
  colnames(df_strg) <- tmp
  colnames(df_vari) <- tmp
  if(nrow(df_strg) == 0){
    stop("SCG is not defined.")
  }else{
    if(nrow(df_vari) == 0){
      metadata(sce)$sign_all <- cbind(CorrType = "SCG", df_strg)
    }else{
      metadata(sce)$sign_all <- rbind(cbind(CorrType = "SCG", df_strg),
                                      cbind(CorrType = "VCG", df_vari))
    }
  }
  #--------------------------------------------------
  # Store the report.
  #--------------------------------------------------
  for(k in seq_along(s_or_v)){
    if(nrow(metadata(sce)[[s_or_v[k]]]) < 2){
      next
    }
    text <- paste(s_or_v[k], "redundant", sep = "_")
    metadata(sce)[[text]] <- report[[k]]
  }

  return(sce)
}
#-----------------------------------------------------------------------------80
#
#-----------------------------------------------------------------------------80
#' Remove signs by specifying keywords.
#'
#' This function removes signs by specifying keywords.
#'
#' @param sce A SingleCellExperiment object.
#' @param keywords keywords separated by pipes `|`.
#'
#' @return A SingleCellExperiment object.
#' @import SingleCellExperiment
#' @import SummarizedExperiment
#' @import S4Vectors
#' @export
#'
#' @examples
#' data(pbmc_eg)
#' data(human_GO_eg)
#' mat <- t(as.matrix(SummarizedExperiment::assay(pbmc_eg, "centered")))
#' pbmc_cormat <- cor(mat, method = "spearman")
#' pbmcs <- list(GO = pbmc_eg)
#' S4Vectors::metadata(pbmcs$GO) <- list(sign = human_GO_eg[["BP"]])
#' pbmcs$GO <- remove_signs(sce = pbmcs$GO, min_ngenes = 2, max_ngenes = 1000)
#' pbmcs$GO <- cluster_genesets(sce = pbmcs$GO, cormat = pbmc_cormat,
#'                              th_posi = 0.24, th_nega = -0.20)
#' pbmcs$GO <- create_signs(sce = pbmcs$GO, min_cnt_strg = 2, min_cnt_vari = 2)
#' keywords <- "Covid19|foofoo|hogehoge"
#' pbmcs$GO <- remove_signs_manually(sce = pbmcs$GO, keywords = keywords)
#' # The results are stored in `metadata(pbmcs$GO)$sign_SCG`,
#' # `metadata(pbmcs$GO)$sign_VCG`, and `metadata(pbmcs$GO)$sign_all`.
#'
remove_signs_manually <- function(sce = NULL, keywords = NULL){
  if(is.null(keywords)){
    return(sce)
  }
  s_or_v <- c("sign_SCG", "sign_VCG")
  for(k in seq_along(s_or_v)){
    df <- metadata(sce)[[s_or_v[k]]]
    if(nrow(df) != 0){
      tmp <- ((grepl(keywords, df$SignID)) | (grepl(keywords, df$Description)))
      df <- df[!tmp, ]
      rownames(df) <- seq_len(nrow(df))
    }
    metadata(sce)[[s_or_v[k]]] <- df
  }
  #--------------------------------------------------
  # Modify metadata(sce)$sign_all.
  #--------------------------------------------------
  df_strg <- as.data.frame(metadata(sce)$sign_SCG)
  df_vari <- as.data.frame(metadata(sce)$sign_VCG)
  tmp <- c("SignID", "Description", "IC",
           "CountCorrGene", "CountWeakCorrGene", "Corr", "CorrWeak",
           "CorrGene", "WeakCorrGene", "CorrGeneID", "WeakCorrGeneID")
  colnames(df_strg) <- tmp
  colnames(df_vari) <- tmp
  if(nrow(df_strg) == 0){
    stop("SCG is not defined.")
  }else{
    if(nrow(df_vari) == 0){
      metadata(sce)$sign_all <- cbind(CorrType = "SCG", df_strg)
    }else{
      metadata(sce)$sign_all <- rbind(cbind(CorrType = "SCG", df_strg),
                                      cbind(CorrType = "VCG", df_vari))
    }
  }

  return(sce)
}
#-----------------------------------------------------------------------------80
#
#-----------------------------------------------------------------------------80
#' Select signs by specifying keywords.
#'
#' This function selects signs by specifying keywords.
#'
#' @param sce An ASURAT object.
#' @param keywords Keywords separated by a pipe.
#'
#' @return An ASURAT object.
#' @import SingleCellExperiment
#' @import SummarizedExperiment
#' @import S4Vectors
#' @export
#'
#' @examples
#' data(pbmc_eg)
#' data(human_GO_eg)
#' mat <- t(as.matrix(SummarizedExperiment::assay(pbmc_eg, "centered")))
#' pbmc_cormat <- cor(mat, method = "spearman")
#' pbmcs <- list(GO = pbmc_eg)
#' S4Vectors::metadata(pbmcs$GO) <- list(sign = human_GO_eg[["BP"]])
#' pbmcs$GO <- remove_signs(sce = pbmcs$GO, min_ngenes = 2, max_ngenes = 1000)
#' pbmcs$GO <- cluster_genesets(sce = pbmcs$GO, cormat = pbmc_cormat,
#'                              th_posi = 0.24, th_nega = -0.20)
#' pbmcs$GO <- create_signs(sce = pbmcs$GO, min_cnt_strg = 2, min_cnt_vari = 2)
#' keywords <- "cell|process"
#' pbmcs$GO <- select_signs_manually(sce = pbmcs$GO, keywords = keywords)
#' # The results are stored in `metadata(pbmcs$GO)$sign_SCG`,
#' # `metadata(pbmcs$GO)$sign_VCG`, and `metadata(pbmcs$GO)$sign_all`.
#'
select_signs_manually <- function(sce = NULL, keywords = NULL){
  if(is.null(keywords)){
    return(sce)
  }
  s_or_v <- c("sign_SCG", "sign_VCG")
  for(k in seq_along(s_or_v)){
    df <- metadata(sce)[[s_or_v[k]]]
    if(nrow(df) != 0){
      tmp <- ((grepl(keywords, df$SignID)) | (grepl(keywords, df$Description)))
      df <- df[tmp, ]
      rownames(df) <- seq_len(nrow(df))
    }
    metadata(sce)[[s_or_v[k]]] <- df
  }
  #--------------------------------------------------
  # Modify metadata(sce)$sign_all.
  #--------------------------------------------------
  df_strg <- as.data.frame(metadata(sce)$sign_SCG)
  df_vari <- as.data.frame(metadata(sce)$sign_VCG)
  tmp <- c("SignID", "Description", "IC",
           "CountCorrGene", "CountWeakCorrGene", "Corr", "CorrWeak",
           "CorrGene", "WeakCorrGene", "CorrGeneID", "WeakCorrGeneID")
  colnames(df_strg) <- tmp
  colnames(df_vari) <- tmp
  if(nrow(df_strg) == 0){
    stop("SCG is not defined. The keywords may not be included in the data.")
  }else{
    if(nrow(df_vari) == 0){
      metadata(sce)$sign_all <- cbind(CorrType = "SCG", df_strg)
    }else{
      metadata(sce)$sign_all <- rbind(cbind(CorrType = "SCG", df_strg),
                                      cbind(CorrType = "VCG", df_vari))
    }
  }

  return(sce)
}
#-----------------------------------------------------------------------------80
#
#-----------------------------------------------------------------------------80
#' Create a new SingleCellExperiment object for sign-by-sample matrices.
#'
#' This function creates a new SingleCellExperiment object for sign-by-sample
#'   matrices (SSM) by concatenating SSMs for strongly and variably correlated
#'   gene sets.
#'
#' @param sce A SingleCellExperiment object.
#' @param weight_strg A weight parameter for strongly correlated gene sets.
#' @param weight_vari A weight parameter for variably correlated gene sets.
#'
#' @return A SingleCellExperiment object.
#' @import SingleCellExperiment
#' @import SummarizedExperiment
#' @import S4Vectors
#' @export
#'
#' @examples
#' data(pbmc_eg)
#' data(human_GO_eg)
#' mat <- t(as.matrix(SummarizedExperiment::assay(pbmc_eg, "centered")))
#' pbmc_cormat <- cor(mat, method = "spearman")
#' pbmcs <- list(GO = pbmc_eg)
#' S4Vectors::metadata(pbmcs$GO) <- list(sign = human_GO_eg[["BP"]])
#' pbmcs$GO <- remove_signs(sce = pbmcs$GO, min_ngenes = 2, max_ngenes = 1000)
#' pbmcs$GO <- cluster_genesets(sce = pbmcs$GO, cormat = pbmc_cormat,
#'                              th_posi = 0.24, th_nega = -0.20)
#' pbmcs$GO <- create_signs(sce = pbmcs$GO, min_cnt_strg = 2, min_cnt_vari = 2)
#' pbmcs$GO <- makeSignMatrix(sce = pbmcs$GO, weight_strg = 0.5,
#'                            weight_vari = 0.5)
#' # The resutls can be check by, e.g., assay(pbmcs$GO, "counts").
#'
makeSignMatrix <- function(sce = NULL, weight_strg = 0.5, weight_vari = 0.5){
  #--------------------------------------------------
  # Error handling
  #--------------------------------------------------
  if((weight_strg == 99) & (weight_strg == 99)){
    message("Search a way to bring harmony.")
  }
  if((weight_strg < 0) | (weight_strg > 1) |
     (weight_vari < 0) | (weight_vari > 1)){
    stop("weight_* must be values in [0, 1].")
  }

  mat <- assay(sce, "centered")
  res <- matrix(ncol = dim(mat)[2], nrow = 0,
                dimnames = list(NULL, colnames(mat)))
  rowdata <- c("ParentSignID", "Description", "CorrGene", "WeakCorrGene", "IC")
  rowdata <- matrix(ncol = 5, nrow = 0, dimnames = list(NULL, rowdata))

  s_or_v <- c("sign_SCG", "sign_VCG")
  for(k in seq_along(s_or_v)){
    df <- metadata(sce)[[s_or_v[k]]]
    if(nrow(df) != 0){
      for(i in seq_len(nrow(df))){
        #--------------------------------------------------
        # Create a sign-by-sample matrix for weakly correlated gene sets
        #--------------------------------------------------
        if(df$CountWeakCorrGene[i] == 0){
          vector_weak <- matrix(0, ncol = dim(mat)[2], nrow = 1,
                                dimnames = list(NULL, colnames(mat)))
        }else{
          genes_weak <- unlist(strsplit(df$WeakCorrGene[i], "/"))
          submat_weak <- matrix(ncol = dim(mat)[2], nrow = 0,
                                dimnames = list(NULL, colnames(mat)))
          inds <- which(rownames(mat) %in% genes_weak)
          submat_weak <- rbind(submat_weak, mat[inds, ])
          vector_weak <- apply(submat_weak, 2, mean)
        }
        #--------------------------------------------------
        # Create a sign-by-sample matrix for strongly correlated gene sets
        #--------------------------------------------------
        if(is.null(df$CountStrgCorrGene[i])){
          ssm_strg <- NA
        }else{
          if(df$CountStrgCorrGene[i] == 0){
            vector_strg <- matrix(0, ncol = dim(mat)[2], nrow = 1,
                                  dimnames = list(NULL, colnames(mat)))
          }else{
            genes_strg <- unlist(strsplit(df$StrgCorrGene[i], "/"))
            submat_strg <- matrix(ncol = dim(mat)[2], nrow = 0,
                                  dimnames = list(NULL, colnames(mat)))
            inds <- which(rownames(mat) %in% genes_strg)
            submat_strg <- rbind(submat_strg, mat[inds, ])
            vector_strg <- apply(submat_strg, 2, mean)
          }
          ssm_strg <- matrix(ncol = dim(mat)[2], nrow = 0,
                             dimnames = list(NULL, colnames(mat)))
          tmp <- weight_strg * vector_strg + (1.0 - weight_strg) * vector_weak
          ssm_strg <- rbind(ssm_strg, tmp)
          rownames(ssm_strg) <- paste(df$SignID[i], "-", "S", sep = "")
          res <- rbind(res, ssm_strg)
          tmp <- data.frame(ParentSignID = df$SignID[i],
                            Description = df$Description[i],
                            CorrGene = df$StrgCorrGene[i],
                            WeakCorrGene = df$WeakCorrGene[i],
                            IC = df$IC[i])
          rowdata <- rbind(rowdata, tmp)
        }
        #--------------------------------------------------
        # Create a sign-by-sample matrix for variably correlated gene sets
        #--------------------------------------------------
        if(is.null(df$CountVariCorrGene[i])){
          ssm_vari <- NA
        }else{
          if(df$CountVariCorrGene[i] == 0){
            vector_vari <- matrix(0, ncol = dim(mat)[2], nrow = 1,
                                  dimnames = list(NULL, colnames(mat)))
          }else{
            genes_vari <- unlist(strsplit(df$VariCorrGene[i], "/"))
            submat_vari <- matrix(ncol = dim(mat)[2], nrow = 0,
                                  dimnames = list(NULL, colnames(mat)))
            inds <- which(rownames(mat) %in% genes_vari)
            submat_vari <- rbind(submat_vari, mat[inds, ])
            vector_vari <- apply(submat_vari, 2, mean)
          }
          ssm_vari <- matrix(ncol = dim(mat)[2], nrow = 0,
                             dimnames = list(NULL, colnames(mat)))
          tmp <- weight_vari * vector_vari + (1.0 - weight_vari) * vector_weak
          ssm_vari <- rbind(ssm_vari, tmp)
          rownames(ssm_vari) <- paste(df$SignID[i], "-", "V", sep = "")
          res <- rbind(res, ssm_vari)
          tmp <- data.frame(ParentSignID = df$SignID[i],
                            Description = df$Description[i],
                            CorrGene = df$VariCorrGene[i],
                            WeakCorrGene = df$WeakCorrGene[i],
                            IC = df$IC[i])
          rowdata <- rbind(rowdata, tmp)
        }
      }
    }
  }
  new_sce <- SingleCellExperiment(assays = list(counts = res),
                                  rowData = rowdata, colData = colData(sce))
  for(k in seq_along(s_or_v)){
    metadata(new_sce)[[s_or_v[k]]] <- metadata(sce)[[s_or_v[k]]]
  }
  if(!is.null(metadata(sce)[["sign_all"]])){
    metadata(new_sce)[["sign_all"]] <- metadata(sce)[["sign_all"]]
  }
  if(length(altExpNames(sce)) != 0){
    for(i in seq_along(altExpNames(sce))){
      altExp(new_sce, altExpNames(sce)[i]) <- altExp(sce, altExpNames(sce)[i])
    }
  }

  return(new_sce)
}

#-----------------------------------------------------------------------------80
#
#-----------------------------------------------------------------------------80
data(pbmc_eg)
data(human_GO_eg)
mat <- t(as.matrix(SummarizedExperiment::assay(pbmc_eg, "centered")))
pbmc_cormat <- cor(mat, method = "spearman")
pbmcs <- list(GO = pbmc_eg)
S4Vectors::metadata(pbmcs$GO) <- list(sign = human_GO_eg[["BP"]])
pbmcs$GO <- remove_signs(sce = pbmcs$GO, min_ngenes = 2, max_ngenes = 1000)

test_that("cluster_genesets() runs properly.", {
  set.seed(1)
  pbmcs$GO <- cluster_genesets(sce = pbmcs$GO, cormat = pbmc_cormat,
                               th_posi = 0.24, th_nega = -0.20)
  expect_equal(nrow(S4Vectors::metadata(pbmcs$GO)$sign), 10)
})

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

## ----message = FALSE, warning = FALSE-----------------------------------------
library(ASURAT)
library(SingleCellExperiment)
library(SummarizedExperiment)

## ----eval = FALSE-------------------------------------------------------------
# mat <- as.matrix(assay(sce, "logcounts"))
# assay(sce, "centered") <- sweep(mat, 1, apply(mat, 1, mean), FUN = "-")

## ----message = FALSE----------------------------------------------------------
sce <- TENxPBMCData::TENxPBMCData(dataset = c("pbmc4k"))
pbmc_counts <- as.matrix(assay(sce, "counts"))
rownames(pbmc_counts) <- make.unique(rowData(sce)$Symbol_TENx)
colnames(pbmc_counts) <- make.unique(colData(sce)$Barcode)

## -----------------------------------------------------------------------------
pbmc_counts[1:5, 1:3]

## -----------------------------------------------------------------------------
pbmc <- SingleCellExperiment(assays = list(counts = pbmc_counts),
                             rowData = data.frame(gene = rownames(pbmc_counts)),
                             colData = data.frame(cell = colnames(pbmc_counts)))

## -----------------------------------------------------------------------------
dim(pbmc)

## -----------------------------------------------------------------------------
pbmc <- add_metadata(sce = pbmc, mitochondria_symbol = "^MT-")

## -----------------------------------------------------------------------------
pbmc <- remove_variables(sce = pbmc, min_nsamples = 10)

## -----------------------------------------------------------------------------
df <- data.frame(x = colData(pbmc)$nReads, y = colData(pbmc)$nGenes)
ggplot2::ggplot() +
  ggplot2::geom_point(ggplot2::aes(x = df$x, y = df$y), size = 1, alpha = 1) +
  ggplot2::labs(x = "Number of reads", y = "Number of genes") +
  ggplot2::theme_classic(base_size = 20)

## -----------------------------------------------------------------------------
df <- data.frame(x = colData(pbmc)$nReads, y = colData(pbmc)$percMT)
ggplot2::ggplot() +
  ggplot2::geom_point(ggplot2::aes(x = df$x, y = df$y), size = 1, alpha = 1) +
  ggplot2::labs(x = "Number of reads", y = "Perc of MT reads") +
  ggplot2::theme_classic(base_size = 20)

## -----------------------------------------------------------------------------
pbmc <- remove_samples(sce = pbmc, min_nReads = 5000, max_nReads = 20000,
                       min_nGenes = 100, max_nGenes = 1e+10,
                       min_percMT = 0, max_percMT = 10)

## -----------------------------------------------------------------------------
df <- data.frame(x = 1:nrow(rowData(pbmc)),
                 y = sort(rowData(pbmc)$nSamples, decreasing = TRUE))
ggplot2::ggplot() + ggplot2::scale_y_log10() +
  ggplot2::geom_point(ggplot2::aes(x = df$x, y = df$y), size = 1, alpha = 1) +
  ggplot2::labs(x = "Rank of genes", y = "Mean read counts") +
  ggplot2::theme_classic(base_size = 20)

## -----------------------------------------------------------------------------
pbmc <- remove_variables_second(sce = pbmc, min_meannReads = 0.05)

## -----------------------------------------------------------------------------
assay(pbmc, "logcounts") <- log(assay(pbmc, "counts") + 1)

## -----------------------------------------------------------------------------
mat <- assay(pbmc, "logcounts")
assay(pbmc, "centered") <- sweep(mat, 1, apply(mat, 1, mean), FUN = "-")

## -----------------------------------------------------------------------------
sname <- "logcounts"
altExp(pbmc, sname) <- SummarizedExperiment(list(counts = assay(pbmc, sname)))

## ----message = FALSE----------------------------------------------------------
dictionary <- AnnotationDbi::select(org.Hs.eg.db::org.Hs.eg.db,
                                    key = rownames(pbmc),
                                    columns = "ENTREZID", keytype = "SYMBOL")
dictionary <- dictionary[!duplicated(dictionary$SYMBOL), ]
rowData(pbmc)$geneID <- dictionary$ENTREZID

## -----------------------------------------------------------------------------
set.seed(1)
nrand_samples <- 1000
mat <- t(as.matrix(assay(pbmc, "centered")))
ids <- sample(rownames(mat), nrand_samples, prob = NULL)
cormat <- cor(mat[ids, ], method = "spearman")

## -----------------------------------------------------------------------------
urlpath <- "https://github.com/keita-iida/ASURATDB/blob/main/genes2bioterm/"
load(url(paste0(urlpath, "20201213_human_CO.rda?raw=TRUE")))         # CO
load(url(paste0(urlpath, "20220308_human_MSigDB.rda?raw=TRUE")))     # MSigDB
load(url(paste0(urlpath, "20201213_human_GO_red.rda?raw=TRUE")))     # GO
load(url(paste0(urlpath, "20201213_human_KEGG.rda?raw=TRUE")))       # KEGG

## -----------------------------------------------------------------------------
d <- list(human_CO[["cell"]], human_MSigDB[["cell"]])
res <- do.call("rbind", d)
human_CB <- list(cell = res)

## -----------------------------------------------------------------------------
pbmcs <- list(CB = pbmc, GO = pbmc, KG = pbmc)
metadata(pbmcs$CB) <- list(sign = human_CB[["cell"]])
metadata(pbmcs$GO) <- list(sign = human_GO[["BP"]])
metadata(pbmcs$KG) <- list(sign = human_KEGG[["pathway"]])

## -----------------------------------------------------------------------------
pbmcs$CB <- remove_signs(sce = pbmcs$CB, min_ngenes = 2, max_ngenes = 1000)
pbmcs$GO <- remove_signs(sce = pbmcs$GO, min_ngenes = 2, max_ngenes = 1000)
pbmcs$KG <- remove_signs(sce = pbmcs$KG, min_ngenes = 2, max_ngenes = 1000)

## -----------------------------------------------------------------------------
set.seed(1)
pbmcs$CB <- cluster_genesets(sce = pbmcs$CB, cormat = cormat,
                             th_posi = 0.30, th_nega = -0.30)
set.seed(1)
pbmcs$GO <- cluster_genesets(sce = pbmcs$GO, cormat = cormat,
                             th_posi = 0.30, th_nega = -0.30)
set.seed(1)
pbmcs$KG <- cluster_genesets(sce = pbmcs$KG, cormat = cormat,
                             th_posi = 0.20, th_nega = -0.20)

## -----------------------------------------------------------------------------
pbmcs$CB <- create_signs(sce = pbmcs$CB, min_cnt_strg = 2, min_cnt_vari = 2)
pbmcs$GO <- create_signs(sce = pbmcs$GO, min_cnt_strg = 4, min_cnt_vari = 4)
pbmcs$KG <- create_signs(sce = pbmcs$KG, min_cnt_strg = 3, min_cnt_vari = 3)

## -----------------------------------------------------------------------------
pbmcs$GO <- remove_signs_redundant(sce = pbmcs$GO,
                                   similarity_matrix = human_GO$similarity_matrix$BP,
                                   threshold = 0.70, keep_rareID = TRUE)

## -----------------------------------------------------------------------------
keywords <- "Covid|COVID"
pbmcs$KG <- remove_signs_manually(sce = pbmcs$KG, keywords = keywords)

## ----eval = FALSE-------------------------------------------------------------
# keywords <- "cell|cyte"
# test <- select_signs_manually(sce = pbmcs$CB, keywords = keywords)

## -----------------------------------------------------------------------------
pbmcs$CB <- makeSignMatrix(sce = pbmcs$CB, weight_strg = 0.5, weight_vari = 0.5)
pbmcs$GO <- makeSignMatrix(sce = pbmcs$GO, weight_strg = 0.5, weight_vari = 0.5)
pbmcs$KG <- makeSignMatrix(sce = pbmcs$KG, weight_strg = 0.5, weight_vari = 0.5)

## -----------------------------------------------------------------------------
rbind(head(assay(pbmcs$CB, "counts")[, 1:3], n = 4),
      tail(assay(pbmcs$CB, "counts")[, 1:3], n = 4))

## -----------------------------------------------------------------------------
pca_dims <- c(30, 30, 50)
tsne_dims <- c(2, 2, 3)
for(i in seq_along(pbmcs)){
  set.seed(1)
  mat <- t(as.matrix(assay(pbmcs[[i]], "counts")))
  res <- Rtsne::Rtsne(mat, dim = tsne_dims[i], pca = TRUE,
                      initial_dims = pca_dims[i])
  reducedDim(pbmcs[[i]], "TSNE") <- res[["Y"]]
}

## -----------------------------------------------------------------------------
df <- as.data.frame(reducedDim(pbmcs$CB, "TSNE"))
ggplot2::ggplot() + ggplot2::geom_point(ggplot2::aes(x = df[, 1], y = df[, 2]),
                                        color = "black", size = 1, alpha = 1) +
  ggplot2::labs(title = "PBMC (cell type)", x = "tSNE_1", y = "tSNE_2") +
  ggplot2::theme_classic(base_size = 15)

## -----------------------------------------------------------------------------
df <- as.data.frame(reducedDim(pbmcs$GO, "TSNE"))
ggplot2::ggplot() + ggplot2::geom_point(ggplot2::aes(x = df[, 1], y = df[, 2]),
                                        color = "black", size = 1, alpha = 1) +
  ggplot2::labs(title = "PBMC (function)", x = "tSNE_1", y = "tSNE_2") +
  ggplot2::theme_classic(base_size = 15)

## -----------------------------------------------------------------------------
df <- as.data.frame(reducedDim(pbmcs$KG, "TSNE"))
plot_dataframe3D(dataframe3D = df, theta = 45, phi = 30, title = "PBMC (pathway)",
                 xlabel = "tSNE_1", ylabel = "tSNE_2", zlabel = "tSNE_3")

## ----message = FALSE, warning = FALSE, results = "hide"-----------------------
resolutions <- c(0.20, 0.20, 0.10)
ds <- list(seq_len(20), seq_len(20), seq_len(20))
for(i in seq_along(pbmcs)){
  surt <- Seurat::as.Seurat(pbmcs[[i]], counts = "counts", data = "counts")
  mat <- as.matrix(assay(pbmcs[[i]], "counts"))
  surt[["SSM"]] <- Seurat::CreateAssayObject(counts = mat)
  Seurat::DefaultAssay(surt) <- "SSM"
  surt <- Seurat::ScaleData(surt, features = rownames(surt))
  surt <- Seurat::RunPCA(surt, features = rownames(surt))
  surt <- Seurat::FindNeighbors(surt, reduction = "pca", dims = ds[[i]])
  surt <- Seurat::FindClusters(surt, resolution = resolutions[i])
  temp <- Seurat::as.SingleCellExperiment(surt)
  colData(pbmcs[[i]])$seurat_clusters <- colData(temp)$seurat_clusters
}

## -----------------------------------------------------------------------------
labels <- colData(pbmcs$CB)$seurat_clusters
df <- as.data.frame(reducedDim(pbmcs$CB, "TSNE"))
ggplot2::ggplot() +
  ggplot2::geom_point(ggplot2::aes(x = df[, 1], y = df[, 2], color = labels),
                      size = 1, alpha = 1) +
  ggplot2::labs(title = "PBMC (cell type)", x = "tSNE_1", y = "tSNE_2", color = "") +
  ggplot2::theme_classic(base_size = 15) + ggplot2::scale_colour_hue() +
  ggplot2::guides(colour = ggplot2::guide_legend(override.aes = list(size = 4)))

## -----------------------------------------------------------------------------
labels <- colData(pbmcs$GO)$seurat_clusters
df <- as.data.frame(reducedDim(pbmcs$GO, "TSNE"))
ggplot2::ggplot() +
  ggplot2::geom_point(ggplot2::aes(x = df[, 1], y = df[, 2], color = labels),
                      size = 1, alpha = 1) +
  ggplot2::labs(title = "PBMC (function)", x = "tSNE_1", y = "tSNE_2", color = "") +
  ggplot2::theme_classic(base_size = 15) +
  ggplot2::scale_colour_brewer(palette = "Set1") +
  ggplot2::guides(colour = ggplot2::guide_legend(override.aes = list(size = 4)))

## -----------------------------------------------------------------------------
labels <- colData(pbmcs$KG)$seurat_clusters
colors <- scales::brewer_pal(palette = "Set2")(length(unique(labels)))[labels]
df <- as.data.frame(reducedDim(pbmcs$KG, "TSNE")[, seq_len(3)])
plot_dataframe3D(dataframe3D = df, labels = labels, colors = colors,
                 theta = 45, phi = 30, title = "PBMC (pathway)",
                 xlabel = "tSNE_1", ylabel = "tSNE_2", zlabel = "tSNE_3")

## ----message = FALSE, warning = FALSE-----------------------------------------
surt <- Seurat::as.Seurat(pbmcs$CB, counts = "counts", data = "counts")
mat <- as.matrix(assay(altExp(pbmcs$CB), "counts"))
surt[["GEM"]] <- Seurat::CreateAssayObject(counts = mat)
Seurat::DefaultAssay(surt) <- "GEM"
surt <- Seurat::ScaleData(surt, features = rownames(surt))
surt <- Seurat::RunPCA(surt, features = rownames(surt))
surt <- Seurat::CellCycleScoring(surt, s.features = Seurat::cc.genes$s.genes,
                                 g2m.features = Seurat::cc.genes$g2m.genes)
temp <- Seurat::as.SingleCellExperiment(surt)
colData(pbmcs$CB)$Phase <- colData(temp)$Phase

## ----message = FALSE, results = "hide"----------------------------------------
for(i in seq_along(pbmcs)){
  set.seed(1)
  labels <- colData(pbmcs[[i]])$seurat_clusters
  pbmcs[[i]] <- compute_sepI_all(sce = pbmcs[[i]], labels = labels,
                                 nrand_samples = 200)
}

## ----message = FALSE----------------------------------------------------------
set.seed(1)
surt <- Seurat::as.Seurat(pbmcs$CB, counts = "counts", data = "counts")
mat <- as.matrix(assay(altExp(pbmcs$CB), "counts"))
surt[["GEM"]] <- Seurat::CreateAssayObject(counts = mat)
Seurat::DefaultAssay(surt) <- "GEM"
surt <- Seurat::SetIdent(surt, value = "seurat_clusters")
res <- Seurat::FindAllMarkers(surt, only.pos = TRUE,
                              min.pct = 0.50, logfc.threshold = 0.50)
metadata(pbmcs$CB)$marker_genes$all <- res

## -----------------------------------------------------------------------------
# Significant signs
marker_signs <- list()
keywords <- "MESENCHYMAL|LIMB|PANCREAS"
for(i in seq_along(pbmcs)){
  marker_signs[[i]] <- metadata(pbmcs[[i]])$marker_signs$all
  marker_signs[[i]] <-
    marker_signs[[i]][!grepl(keywords, marker_signs[[i]]$Description), ]
  marker_signs[[i]] <- dplyr::group_by(marker_signs[[i]], Ident_1)
  marker_signs[[i]] <- dplyr::slice_max(marker_signs[[i]], sepI, n = 2)
  marker_signs[[i]] <- dplyr::slice_min(marker_signs[[i]], Rank, n = 1)
}
# Significant genes
marker_genes_CB <- metadata(pbmcs$CB)$marker_genes$all
marker_genes_CB <- dplyr::group_by(marker_genes_CB, cluster)
marker_genes_CB <- dplyr::slice_min(marker_genes_CB, p_val_adj, n = 2)
marker_genes_CB <- dplyr::slice_max(marker_genes_CB, avg_log2FC, n = 1)

## -----------------------------------------------------------------------------
# ssm_list
sces_sub <- list() ; ssm_list <- list()
for(i in seq_along(pbmcs)){
  sces_sub[[i]] <- pbmcs[[i]][rownames(pbmcs[[i]]) %in% marker_signs[[i]]$SignID, ]
  ssm_list[[i]] <- assay(sces_sub[[i]], "counts")
}
names(ssm_list) <- c("SSM_cell", "SSM_function", "SSM_pathway")
# gem_list
expr_sub <- altExp(pbmcs$CB, "logcounts")
expr_sub <- expr_sub[rownames(expr_sub) %in% marker_genes_CB$gene]
gem_list <- list(GeneExpr = assay(expr_sub, "counts"))
# ssmlabel_list
labels <- list() ; ssmlabel_list <- list()
for(i in seq_along(pbmcs)){
  tmp <- colData(sces_sub[[i]])$seurat_clusters
  labels[[i]] <- data.frame(label = tmp)
  n_groups <- length(unique(tmp))
  if(i == 1){
    labels[[i]]$color <- scales::hue_pal()(n_groups)[tmp]
  }else if(i == 2){
    labels[[i]]$color <- scales::brewer_pal(palette = "Set1")(n_groups)[tmp]
  }else if(i == 3){
    labels[[i]]$color <- scales::brewer_pal(palette = "Set2")(n_groups)[tmp]
  }
  ssmlabel_list[[i]] <- labels[[i]]
}
names(ssmlabel_list) <- c("Label_cell", "Label_function", "Label_pathway")
# gemlabel_list
label_CC <- data.frame(label = colData(pbmcs$CB)$Phase, color = NA)
gemlabel_list <- list(CellCycle = label_CC)

## ----message = FALSE, warning = FALSE-----------------------------------------
set.seed(1)
plot_multiheatmaps(ssm_list = ssm_list, gem_list = gem_list,
                   ssmlabel_list = ssmlabel_list, gemlabel_list = gemlabel_list,
                   nrand_samples = 100, show_row_names = TRUE, title = "PBMC")

## -----------------------------------------------------------------------------
labels <- colData(pbmcs$CB)$seurat_clusters
variable <- "GO:0042100-V"
description <- "B cell proliferation"
subsce <- pbmcs$GO[which(rownames(pbmcs$GO) == variable), ]
df <- as.data.frame(t(as.matrix(assay(subsce, "counts"))))
ggplot2::ggplot() +
  ggplot2::geom_violin(ggplot2::aes(x = as.factor(labels), y = df[, 1],
                                    fill = labels), trim = FALSE, size = 0.5) +
  ggplot2::geom_boxplot(ggplot2::aes(x = as.factor(labels), y = df[, 1]),
                        width = 0.15, alpha = 0.6) +
  ggplot2::labs(title = paste0(variable, "\n", description),
                x = "Cluster (cell type)", y = "Sign score") +
  ggplot2::theme_classic(base_size = 20) +
  ggplot2::theme(legend.position = "none") + ggplot2::scale_fill_hue()

## -----------------------------------------------------------------------------
vname <- "CD79A"
sub <- altExp(pbmcs$CB, "logcounts")
sub <- sub[rownames(sub) == vname, ]
labels <- colData(pbmcs$CB)$seurat_clusters
df <- as.data.frame(t(assay(sub, "counts")))
ggplot2::ggplot() +
  ggplot2::geom_violin(ggplot2::aes(x = as.factor(labels), y = df[, 1],
                                    fill = labels), trim = FALSE, size = 0.5) +
  ggplot2::geom_boxplot(ggplot2::aes(x = as.factor(labels), y = df[, 1]),
                        width = 0.15, alpha = 0.6) +
  ggplot2::labs(title = vname, x = "Cluster (cell type)",
                y = "Normalized expression") +
  ggplot2::theme_classic(base_size = 20) +
  ggplot2::theme(legend.position = "none") + ggplot2::scale_fill_hue()

## -----------------------------------------------------------------------------
sessionInfo()

# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

#' Perform one-shot adjacent swapping for each element.
#'
#' @param listdata A list of vector and integer.
#'   
#' @return A List.
#' @export
#'
#' @examples
#' swap_pass(list(vec = c(1, 1, 0), cnt = 0))
#'
swap_pass <- function(listdata) {
    .Call('_ASURAT_swap_pass', PACKAGE = 'ASURAT', listdata)
}

#' Perform bubble sorting, counting the number of steps.
#'
#' @param listdata A list of vector and integer.
#'   For example, in R code, listdata = list(vec = c(1, 0, 1, ...), cnt = 0).
#'   The integer (cnt = 0) is the initial number of steps for bubble sorting.
#'
#' @return A List.
#' @export
#'
#' @examples
#' bubble_sort(list(vec = c(1, 1, 0), cnt = 0))
#'
bubble_sort <- function(listdata) {
    .Call('_ASURAT_bubble_sort', PACKAGE = 'ASURAT', listdata)
}

#-----------------------------------------------------------------------------80
# 
#-----------------------------------------------------------------------------80
#' Visualize a three-dimensional data with labels and colors.
#'
#' This function visualizes a three-dimensional data with labels and colors.
#'
#' @param dataframe3D A dataframe with three columns.
#' @param labels NULL or a vector of labels of all the samples,
#'   corresponding to colors.
#' @param colors NULL or a vector of colors of all the samples,
#'   corresponding to labels.
#' @param theta Angle of the plot.
#' @param phi Angle of the plot.
#' @param title Title.
#' @param xlabel x-axis label.
#' @param ylabel y-axis label.
#' @param zlabel z-axis label.
#'
#' @return A scatter3D object in plot3D package.
#' @import plot3D
#' @export
#'
#' @examples
#' data(pbmcs_eg)
#' mat <- SingleCellExperiment::reducedDim(pbmcs_eg$CM, "UMAP")[, 1:3]
#' dataframe3D <- as.data.frame(mat)
#' labels <- SummarizedExperiment::colData(pbmcs_eg$CM)$seurat_clusters
#' plot_dataframe3D(dataframe3D = dataframe3D, labels = labels, colors = NULL,
#'                  theta = 45, phi = 20, title = "PBMC (CO & MSigDB)",
#'                  xlabel = "UMAP_1", ylabel = "UMAP_2", zlabel = "UMAP_3")
#'
plot_dataframe3D <- function(
  dataframe3D = NULL, labels = NULL, colors = NULL, theta = 30, phi = 30,
  title = "", xlabel = "", ylabel = "", zlabel = ""
){
  if(is.null(labels)){
    scatter3D(dataframe3D[, 1], dataframe3D[, 2], dataframe3D[, 3],
              main = title, xlab = xlabel, ylab = ylabel, zlab = zlabel,
              box = TRUE, bty = "b2", axes = TRUE, nticks = 5,
              theta = theta, phi = phi, pch = 16, cex = 0.5, alpha = 1.0,
              col = "black", colvar = NA, colkey = FALSE)
  }else{
    if(is.null(colors)){
      myggcolor <- function(n, l = 65){
        hues <- seq(15, 375, length = n + 1)
        grDevices::hcl(h = hues, l = l, c = 100)[seq_len(n)]
      }
      colors <- myggcolor(length(unique(labels))) ; colors <- colors[labels]
      dataframe3D$label <- labels ; dataframe3D$color <- colors
      dataframe3D <- dataframe3D[order(dataframe3D$label), ]
      scatter3D(dataframe3D[, 1], dataframe3D[, 2], dataframe3D[, 3],
                main = title, xlab = xlabel, ylab = ylabel, zlab = zlabel,
                box = TRUE, bty = "b2", axes = TRUE, nticks = 5,
                theta = theta, phi = phi, pch = 16, cex = 0.5, alpha = 1.0,
                col = dataframe3D$color, colvar = NA, colkey = FALSE)
      graphics::legend("bottomright", legend = unique(dataframe3D$label),
                       pch = 16, col = unique(dataframe3D$color), cex = 1.2,
                       inset = c(0.02))
    }else{
      dataframe3D$label <- labels ; dataframe3D$color <- colors
      dataframe3D <- dataframe3D[order(dataframe3D$label), ]
      scatter3D(dataframe3D[, 1], dataframe3D[, 2], dataframe3D[, 3],
                main = title, xlab = xlabel, ylab = ylabel, zlab = zlabel,
                box = TRUE, bty = "b2", axes = TRUE, nticks = 5,
                theta = theta, phi = phi, pch = 16, cex = 0.5, alpha = 1.0,
                col = dataframe3D$color, colvar = NA, colkey = FALSE)
      graphics::legend("bottomright", legend=unique(dataframe3D$label),
                       pch = 16, col = unique(dataframe3D$color), cex = 1.2,
                       inset = c(0.02))
    }
  }
}
#-----------------------------------------------------------------------------80
# 
#-----------------------------------------------------------------------------80
#' Visualize multivariate data by heatmaps.
#'
#' This function visualizes multivariate data by heatmaps.
#'
#' @param ssm_list A list of sign-by-sample matrices.
#' @param gem_list A list of gene-by-sample matrices.
#' @param ssmlabel_list NULL or a list of dataframes of sample (cell)
#'   labels and colors.
#'   The length of the list must be as same as that of ssm_list, and
#'   the order of labels in each list must be as same as those in ssm_list.
#' @param gemlabel_list NULL or a list of dataframes of sample (cell)
#'   annotations and colors.
#'   The length of the list must be as same as that of gem_list, and
#'   the order of labels in each list must be as same as those in gem_list.
#' @param nrand_samples Number of samples (cells) used for random sampling.
#' @param show_row_names TRUE or FALSE: if TRUE, row names are shown.
#' @param title Title.
#'
#' @return A ComplexHeatmap object.
#' @import ComplexHeatmap
#' @import circlize
#' @import grid
#' @export
#'
#' @examples
#' data(pbmcs_eg)
#' mat_CM <- SummarizedExperiment::assay(pbmcs_eg$CM, "counts")
#' mat_GO <- SummarizedExperiment::assay(pbmcs_eg$GO, "counts")
#' mat_KG <- SummarizedExperiment::assay(pbmcs_eg$KG, "counts")
#' ssm_list <- list(SSM_COMSig = mat_CM, SSM_GO = mat_GO, SSM_KEGG = mat_KG)
#' se <- SingleCellExperiment::altExp(pbmcs_eg$CM, "logcounts")
#' mat <- SummarizedExperiment::assay(se, "counts")
#' se <- SingleCellExperiment::altExp(pbmcs_eg$CM, "logcounts")
#' gem_list <- list(GeneExpr = SummarizedExperiment::assay(se, "counts"))
#' labels <- list() ; ssmlabel_list <- list()
#' for(i in seq_along(pbmcs_eg)){
#'   fa <- SummarizedExperiment::colData(pbmcs_eg[[i]])$seurat_clusters
#'   labels[[i]] <- data.frame(label = fa)
#'   colors <- rainbow(length(unique(labels[[i]]$label)))[labels[[i]]$label]
#'   labels[[i]]$color <- colors
#'   ssmlabel_list[[i]] <- labels[[i]]
#' }
#' names(ssmlabel_list) <- c("Label_COMSig", "Label_GO", "Label_KEGG")
#' phases <- SummarizedExperiment::colData(pbmcs_eg$CM)$Phase
#' label_CC <- data.frame(label = phases, color = NA)
#' gemlabel_list <- list(CellCycle = label_CC)
#' plot_multiheatmaps(ssm_list = ssm_list, gem_list = gem_list,
#'                    ssmlabel_list = ssmlabel_list,
#'                    gemlabel_list = gemlabel_list, nrand_samples = 50,
#'                    show_row_names = FALSE, title = "PBMC")
#'
plot_multiheatmaps <- function(
  ssm_list = NULL, gem_list = NULL, ssmlabel_list = NULL, gemlabel_list = NULL,
  nrand_samples = NULL, show_row_names = FALSE, title = NULL
){
  #--------------------------------------------------
  # Error handling
  #--------------------------------------------------
  if(dim(ssm_list[[1]])[2] > 2000){
    warning("Huge sample size> 2000. It is recommended to use nrand_samples.")
  }
  #--------------------------------------------------
  # Set names of dataframes.
  #--------------------------------------------------
  if(!is.null(ssmlabel_list)){
    for(i in seq_along(ssmlabel_list)){
      colnames(ssmlabel_list[[i]]) <- c("label", "color")
    }
  }
  if(!is.null(gemlabel_list)){
    for(i in seq_along(gemlabel_list)){
      colnames(gemlabel_list[[i]]) <- c("label", "color")
    }
  }
  #--------------------------------------------------
  # Fix ComplexHeatmap parameters.
  #--------------------------------------------------
  if(show_row_names){
    nrow_max <- 1
    for(i in seq_along(ssm_list)){
      if(nrow_max < dim(ssm_list[[i]])[1]){
        nrow_max <- dim(ssm_list[[i]])[1]
      }
    }
    for(i in seq_along(gem_list)){
      if(nrow_max < dim(gem_list[[i]])[1]){
        nrow_max <- dim(gem_list[[i]])[1]
      }
    }
    if(nrow_max > 200){
      message("Row names are removed because the number of rows> 200.")
      show_row_names <- FALSE
      row_names_side <- NULL
    }else{
      row_names_side <- "left"
    }
  }
  show_row_dend <- FALSE
  cluster_row_slices <- FALSE
  show_column_names <- FALSE
  column_dend_side <- "top"
  cluster_column_slices <- FALSE
  border <- FALSE
  #--------------------------------------------------
  # Random sampling
  #--------------------------------------------------
  if(!is.null(nrand_samples)){
    inds <- sample(ncol(ssm_list[[1]]), size = nrand_samples, replace = FALSE)
    for(i in seq_along(ssm_list)){
      ssm_list[[i]] <- ssm_list[[i]][, inds]
    }
    for(i in seq_along(ssmlabel_list)){
      ssmlabel_list[[i]] <- ssmlabel_list[[i]][inds, ]
    }
    for(i in seq_along(gem_list)){
      gem_list[[i]] <- gem_list[[i]][, inds]
    }
    for(i in seq_along(gemlabel_list)){
      gemlabel_list[[i]] <- gemlabel_list[[i]][inds, ]
    }
  }
  #--------------------------------------------------
  # Compute heatmaps of sign-by-sample matrices.
  #--------------------------------------------------
  p <- c()
  ha <- list()
  for(i in seq_along(ssm_list)){
    if((!is.element(NA, ssmlabel_list[[i]]$label)) &
       (!is.null(ssmlabel_list[[i]]$label))){
      inds <- order(ssmlabel_list[[i]]$label)
      if((!is.element(NA, ssmlabel_list[[i]]$color)) &
         (!is.null(ssmlabel_list[[i]]$color))){
        mycolor <- unique(ssmlabel_list[[i]][inds, ]$color)
      }else{
        myggcolor <- function(n, l = 65){
          hues <- seq(15, 375, length = n + 1)
          grDevices::hcl(h = hues, l = l, c = 100)[seq_len(n)]
        }
        mycolor <- myggcolor(length(unique(ssmlabel_list[[i]]$label)))
      }
      names(mycolor) <- unique(ssmlabel_list[[i]][inds, ]$label)
      mycolor <- list(mycolor)
      names(mycolor) <- names(ssmlabel_list)[[i]]
      mylabel <- list(ssmlabel_list[[i]]$label)
      names(mylabel) <- names(ssmlabel_list)[[i]]
      ha[[i]] <- HeatmapAnnotation(df = mylabel, col = mycolor,
                                   annotation_name_side = "left")

      if(show_row_names){
        q <- Heatmap(as.matrix(ssm_list[[i]]), top_annotation = ha[[i]],
                     # Row data
                     row_names_side = row_names_side, show_row_dend = FALSE,
                     cluster_row_slices = cluster_row_slices,
                     row_gap = unit(1.0, "mm"),
                     # Column data
                     show_column_names = show_column_names,
                     column_dend_side = column_dend_side,
                     column_split = ssmlabel_list[[i]]$label,
                     column_gap = unit(1.5, "mm"),
                     cluster_column_slices = cluster_column_slices,
                     column_title = title,
                     # Option
                     name = names(ssm_list)[[i]], border = border)
      }else{
        q <- Heatmap(as.matrix(ssm_list[[i]]), top_annotation = ha[[i]],
                     # Row data
                     show_row_names = show_row_names,
                     show_row_dend = show_row_dend,
                     cluster_row_slices = cluster_row_slices,
                     row_gap = unit(1.0, "mm"),
                     # Column data
                     show_column_names = show_column_names,
                     column_dend_side = column_dend_side,
                     column_split = ssmlabel_list[[i]]$label,
                     column_gap = unit(1.5, "mm"),
                     cluster_column_slices = cluster_column_slices,
                     column_title = title,
                     # Option
                     name = names(ssm_list)[[i]], border = border)
      }
    }else{
      if(show_row_names){
        q <- Heatmap(as.matrix(ssm_list[[i]]), top_annotation = NULL,
                     # Row data
                     row_names_side = row_names_side, show_row_dend = FALSE,
                     cluster_row_slices = cluster_row_slices,
                     row_gap = unit(1.0, "mm"),
                     # Column data
                     show_column_names = show_column_names,
                     column_dend_side = column_dend_side,
                     column_split = ssmlabel_list[[i]]$label,
                     column_gap = unit(1.5, "mm"),
                     cluster_column_slices = cluster_column_slices,
                     column_title = title,
                     # Option
                     name = names(ssm_list)[[i]], border = border)
      }else{
        q <- Heatmap(as.matrix(ssm_list[[i]]), top_annotation = NULL,
                     # Row data
                     show_row_names = show_row_names,
                     show_row_dend = show_row_dend,
                     cluster_row_slices = cluster_row_slices,
                     row_gap = unit(1.0, "mm"),
                     # Column data
                     show_column_names = show_column_names,
                     column_dend_side = column_dend_side,
                     column_split = ssmlabel_list[[i]]$label,
                     column_gap = unit(1.5, "mm"),
                     cluster_column_slices = cluster_column_slices,
                     column_title = title,
                     # Option
                     name = names(ssm_list)[[i]], border = border)
      }
    }
    p <- p %v% q
  }
  #--------------------------------------------------
  # Compute heatmaps of gene-by-sample matrices.
  #--------------------------------------------------
  ha2 <- list()
  for(i in seq_along(gem_list)){
    if((!is.element(NA, gemlabel_list[[i]]$label)) &
       (!is.null(gemlabel_list[[i]]$label))){
      inds <- order(gemlabel_list[[i]]$label)
      if((!is.element(NA, gemlabel_list[[i]]$color)) &
         (!is.null(gemlabel_list[[i]]$color))){
        mycolor <- unique(gemlabel_list[[i]][inds, ]$color)
      }else{
        myggcolor <- function(n, l = 65){
          hues <- seq(15, 375, length = n + 1)
          grDevices::hcl(h = hues, l = l, c = 100)[seq_len(n)]
        }
        mycolor <- myggcolor(length(unique(gemlabel_list[[i]]$label)))
      }
      names(mycolor) <- unique(gemlabel_list[[i]][inds, ]$label)
      mycolor <- list(mycolor)
      names(mycolor) <- names(gemlabel_list)[[i]]
      mylabel <- list(gemlabel_list[[i]]$label)
      names(mylabel) <- names(gemlabel_list)[[i]]
      ha2[[i]] <- HeatmapAnnotation(df = mylabel, col = mycolor,
                                    annotation_name_side = "left")

      if(show_row_names){
        q <- Heatmap(as.matrix(gem_list[[i]]), top_annotation = ha2[[i]],
                     # Row data
                     row_names_side = row_names_side, show_row_dend = FALSE,
                     cluster_row_slices = cluster_row_slices,
                     row_gap = unit(1.0, "mm"),
                     # Column data
                     show_column_names = show_column_names,
                     column_dend_side = column_dend_side,
                     column_split = ssmlabel_list[[i]]$label,
                     column_gap = unit(1.5, "mm"),
                     cluster_column_slices = cluster_column_slices,
                     column_title = title,
                     # Option
                     name = names(gem_list)[[i]], border = border)
      }else{
        q <- Heatmap(as.matrix(gem_list[[i]]), top_annotation = ha2[[i]],
                     # Row data
                     show_row_names = show_row_names,
                     show_row_dend = show_row_dend,
                     cluster_row_slices = cluster_row_slices,
                     row_gap = unit(1.0, "mm"),
                     # Column data
                     show_column_names = show_column_names,
                     column_dend_side = column_dend_side,
                     column_split = ssmlabel_list[[i]]$label,
                     column_gap = unit(1.5, "mm"),
                     cluster_column_slices = cluster_column_slices,
                     column_title = title,
                     # Option
                     name = names(gem_list)[[i]], border = border)
      }
    }else{
      if(show_row_names){
        q <- Heatmap(as.matrix(gem_list[[i]]), top_annotation = NULL,
                     # Row data
                     row_names_side = row_names_side, show_row_dend = FALSE,
                     cluster_row_slices = cluster_row_slices,
                     row_gap = unit(1.0, "mm"),
                     # Column data
                     show_column_names = show_column_names,
                     column_dend_side = column_dend_side,
                     column_split = ssmlabel_list[[i]]$label,
                     column_gap = unit(1.5, "mm"),
                     cluster_column_slices = cluster_column_slices,
                     column_title = title,
                     # Option
                     name = names(gem_list)[[i]], border = border)
      }else{
        q <- Heatmap(as.matrix(gem_list[[i]]), top_annotation = NULL,
                     # Row data
                     show_row_names = show_row_names,
                     show_row_dend = show_row_dend,
                     cluster_row_slices = cluster_row_slices,
                     row_gap = unit(1.0, "mm"),
                     # Column data
                     show_column_names = show_column_names,
                     column_dend_side = column_dend_side,
                     column_split = ssmlabel_list[[i]]$label,
                     column_gap = unit(1.5, "mm"),
                     cluster_column_slices = cluster_column_slices,
                     column_title = title,
                     # Option
                     name = names(gem_list)[[i]], border = border)
      }
    }
    p <- p %v% q
  }

  return(p)
}

#-----------------------------------------------------------------------------80
#
#-----------------------------------------------------------------------------80
#' Compute separation indices of sign scores for given two clusters.
#'
#' This function computes separation indices of sign scores for given two
#'   clusters.
#'
#' @param sce A SingleCellExperiment object.
#' @param labels A vector of labels of all the samples.
#' @param nrand_samples An integer for the number of samples used for
#'   random sampling, which samples at least one sample per cluster.
#' @param ident_1 Label names identifying cluster numbers,
#'   e.g., ident_1 = 1, ident_1 = c(1, 3).
#' @param ident_2 Label names identifying cluster numbers,
#'   e.g., ident_2 = 2, ident_2 = c(2, 4).
#'
#' @return A SingleCellExperiment object.
#' @import SingleCellExperiment
#' @import SummarizedExperiment
#' @import S4Vectors
#' @export
#'
#' @examples
#' data(pbmcs_eg)
#' labels <- SummarizedExperiment::colData(pbmcs_eg$GO)$seurat_clusters
#' pbmcs_eg$GO <- compute_sepI_clusters(sce = pbmcs_eg$GO, labels = labels,
#'                                      nrand_samples = 10, ident_1 = 1,
#'                                      ident_2 = c(0, 2))
#' # The results are stored in `metadata(pbmcs_eg$GO)$marker_signs`.
#'
compute_sepI_clusters <- function(
  sce = NULL, labels = NULL, nrand_samples = NULL,
  ident_1 = NULL, ident_2 = NULL
){
  #--------------------------------------------------
  # Error handling
  #--------------------------------------------------
  if((length(unique(sort(labels))) <= 1) || (is.null(labels))){
    stop("Insufficient labels for calculating separation index.")
  }
  if(length(intersect(ident_1, ident_2)) != 0){
    stop("ident_1 and ident_2 must be disjoint.")
  }
  if(dim(sce)[2] != length(labels)){
    stop("dim(sce)[2] must be equal to length(labels).")
  }
  if(!is.null(nrand_samples)){
    tmp <- sce[, colnames(sce)[which(labels %in% union(ident_1, ident_2))]]
    if(dim(tmp)[2] < nrand_samples){
      stop("nrand_samples must be<= the number of identified samples.")
    }
  }
  #--------------------------------------------------
  # Preparation
  #--------------------------------------------------
  idents <- sort(union(ident_1, ident_2))
  labels <- as.character(labels)
  #--------------------------------------------------
  # Random sampling
  #--------------------------------------------------
  if(!(is.null(nrand_samples))){
    index_list <- list()
    baseindex_list <- list()
    nonbaseindex_list <- list()
    for(i in seq_along(idents)){
      index_list[[i]] <- which(labels == idents[i])
      if(length(index_list[[i]]) == 1){
        baseindex_list[[i]] <- index_list[[i]]
      }else{
        baseindex_list[[i]] <- sample(index_list[[i]], 1, prob = NULL)
      }
      nonbaseindex_list[[i]] <- setdiff(index_list[[i]], baseindex_list[[i]])
    }
    nonbaseindices <- unlist(nonbaseindex_list)
    n <- nrand_samples - length(idents)
    if(length(nonbaseindices) >= 2){
      nonbaseindices <- sample(nonbaseindices, n, prob = NULL)
    }
    final_idents <- union(unlist(baseindex_list), nonbaseindices)
    subsce <- sce[, final_idents]
    popu_1 <- colnames(sce)[final_idents[labels[final_idents] %in% ident_1]]
  }else{
    subsce <- sce[, colnames(sce)[which(labels %in% union(ident_1, ident_2))]]
    popu_1 <- colnames(sce)[which(labels %in% ident_1)]
  }
  submat <- as.matrix(assay(subsce, "counts"))
  #--------------------------------------------------
  # Compute separation indices.
  #--------------------------------------------------
  res <- data.frame(
    Ident_1 = paste(ident_1, collapse = "/"),
    Ident_2 = paste(ident_2, collapse = "/"),
    SignID = NA,
    Description = NA,
    CorrGene = NA,
    WeakCorrGene = NA,
    sepI = NA,
    Rank = rep(NA, dim(subsce)[1])
  )
  for(i in seq_len(dim(subsce)[1])){
    res$SignID[i] <- rownames(subsce)[i]
    res$Description[i] <- rowData(subsce)$Description[i]
    res$CorrGene[i] <- rowData(subsce)$CorrGene[i]
    res$WeakCorrGene[i] <- rowData(subsce)$WeakCorrGene[i]
    #--------------------------------------------------
    # Preparation
    #--------------------------------------------------
    data <- submat[which(rownames(submat) == res$SignID[i]), ]
    vec_1 <- sort(data, decreasing = FALSE)
    vec_1 <- ifelse(names(vec_1) %in% popu_1, 1, 0)
    #--------------------------------------------------
    # Count the number of steps in bubble sort.
    #--------------------------------------------------
    dist1 <- bubble_sort(list(vec_1, 0))[[2]]     # dist(vec_1, (0,...,1)).
    dist2 <- bubble_sort(list(1 - vec_1, 0))[[2]] # dist(vec_1, (1,...,0)).
    res$sepI[i] <- round((dist2 - dist1) / (dist2 + dist1), digits = 6)
  }
  #--------------------------------------------------
  # Arrange the data frame in order of res$sepI
  #--------------------------------------------------
  inds <- order(res$sepI, decreasing = TRUE)
  res <- res[inds, ]
  res$Rank <- seq_along(inds)
  rownames(res) <- seq_len(nrow(res))
  #--------------------------------------------------
  # Output
  #--------------------------------------------------
  slot_name <- paste("Label_", paste(ident_1, collapse = "/"), "_vs_",
                     paste(ident_2, collapse = "/"), sep = "")
  metadata(sce)$marker_signs[[slot_name]] <- res

  return(sce)
}
#-----------------------------------------------------------------------------80
#
#-----------------------------------------------------------------------------80
#' Compute separation indices for each cluster against the others.
#'
#' This function computes separation indices for each cluster versus the others.
#'
#' @param sce A SingleCellExperiment object.
#' @param labels A vector of labels of all the samples (cells).
#' @param nrand_samples An integer for the number of samples used for
#'   random sampling, which samples at least one sample per cluster.
#'
#' @return A SingleCellExperiment object.
#' @import SingleCellExperiment
#' @import SummarizedExperiment
#' @import S4Vectors
#' @importFrom utils txtProgressBar setTxtProgressBar
#' @export
#'
#' @examples
#' data(pbmcs_eg)
#' labels <- SummarizedExperiment::colData(pbmcs_eg$GO)$seurat_clusters
#' pbmcs_eg$GO <- compute_sepI_all(sce = pbmcs_eg$GO, labels = labels,
#'                                 nrand_samples = 10)
#' # The results are stored in `metadata(pbmcs_eg$GO)$marker_signs`.
#'
compute_sepI_all <- function(sce = NULL, labels = NULL, nrand_samples = NULL){
  #--------------------------------------------------
  # Error handling
  #--------------------------------------------------
  if((length(unique(sort(labels))) <= 1) || (is.null(labels))){
    stop("Insufficient labels for calculating separation index.")
  }
  #--------------------------------------------------
  # Preparation
  #--------------------------------------------------
  res <- list()
  tmp <- sce
  metadata(tmp)$marker_signs <- NULL
  #--------------------------------------------------
  # Loop
  #--------------------------------------------------
  idents <- unique(sort(labels))

  # Initializes the progress bar
  pb <- txtProgressBar(min = 0, max = length(idents), style = 3,
                       width = 50, char = "=")
  for(i in seq_along(idents)){
    setTxtProgressBar(pb, i)
    ident_1 <- idents[i]
    ident_2 <- setdiff(idents, ident_1)
    tmp <- compute_sepI_clusters(sce = tmp, labels = labels,
                                 nrand_samples = nrand_samples,
                                 ident_1 = ident_1, ident_2 = ident_2)
    res[[i]] <- metadata(tmp)$marker_signs[[i]]
    slot_name <- paste("Label_", paste(ident_1, collapse = "/"), "_vs_",
                       paste(ident_2, collapse = "/"), sep = "")
    metadata(sce)$marker_signs[[slot_name]] <- res[[i]]
  }
  close(pb)
  res_all <- c()
  for(i in seq_along(res)){
    res_all <- rbind(res_all, res[[i]])
  }
  rownames(res_all) <- seq_len(nrow(res_all))
  metadata(sce)$marker_signs$all <- res_all

  return(sce)
}

#-----------------------------------------------------------------------------80
#
#-----------------------------------------------------------------------------80
#' Add metadata of variables and samples.
#'
#' This function adds metadata of variables and samples.
#'
#' @param sce A SingleCellExperiment object.
#' @param mitochondria_symbol A string representing for mitochondrial genes.
#'   This function computes percents of reads that map to the mitochondrial
#'   genes. Examples are `^MT-`, `^mt-`, etc.
#'
#' @return A SingleCellExperiment object.
#' @import SingleCellExperiment
#' @import SummarizedExperiment
#' @export
#'
#' @examples
#' data(pbmc_eg)
#' pbmc <- add_metadata(sce = pbmc_eg, mitochondria_symbol = "^MT-")
#'
add_metadata <- function(sce = NULL, mitochondria_symbol = NULL){
  mat <- assay(sce, "counts")
  #--------------------------------------------------
  # Variable metadata
  #--------------------------------------------------
  rowData(sce)$nSamples <- apply(mat, 1, function(x) sum(x > 0))
  #--------------------------------------------------
  # Sample metadata
  #--------------------------------------------------
  sce$nReads <- as.integer(apply(mat, 2, function(x) sum(x)))
  sce$nGenes <- as.integer(apply(mat, 2, function(x) sum(x > 0)))
  sce$percMT <- apply(mat[grepl(mitochondria_symbol, rownames(mat)), ],
                      2, function(x) 100 * sum(x)) /
                  apply(mat, 2, function(x) sum(x))

  return(sce)
}
#-----------------------------------------------------------------------------80
#
#-----------------------------------------------------------------------------80
#' Remove variables based on expression profiles across samples.
#'
#' This function removes low expressed variable data.
#'
#' @param sce A SingleCellExperiment object.
#' @param min_nsamples An integer. This function removes variables for which
#'   the numbers of non-zero expressing samples are less than this value.
#'
#' @return A SingleCellExperiment object.
#' @import SingleCellExperiment
#' @import SummarizedExperiment
#' @export
#'
#' @examples
#' data(pbmc_eg)
#' pbmc <- add_metadata(sce = pbmc_eg, mitochondria_symbol = "^MT-")
#' pbmc <- remove_variables(sce = pbmc, min_nsamples = 10)
#'
remove_variables <- function(sce = NULL, min_nsamples = 0){
  mat <- assay(sce, "counts")
  inds <- which(apply(mat, 1, function(x) sum(x > 0)) >= min_nsamples)

  return(sce[inds, ])
}
#-----------------------------------------------------------------------------80
#
#-----------------------------------------------------------------------------80
#' Remove samples based on expression profiles across variables.
#'
#' This function removes sample data by setting minimum and maximum threshold
#'   values for the metadata.
#'
#' @param sce A SingleCellExperiment object.
#' @param min_nReads A minimum threshold value of the number of reads.
#' @param max_nReads A maximum threshold value of the number of reads.
#' @param min_nGenes A minimum threshold value of the number of non-zero
#'   expressed genes.
#' @param max_nGenes A maximum threshold value of the number of non-zero
#'   expressed genes.
#' @param min_percMT A minimum threshold value of the percent of reads that map
#'   to mitochondrial genes.
#' @param max_percMT A maximum threshold value of the percent of reads that map
#'   to mitochondrial genes.
#'
#' @return A SingleCellExperiment object.
#' @import SingleCellExperiment
#' @import SummarizedExperiment
#' @export
#'
#' @examples
#' data(pbmc_eg)
#' pbmc <- add_metadata(sce = pbmc_eg, mitochondria_symbol = "^MT-")
#' pbmc <- remove_samples(sce = pbmc, min_nReads = 0, max_nReads = 1e+10,
#'                        min_nGenes = 0, max_nGenes = 1e+10,
#'                        min_percMT = NULL, max_percMT = NULL)
#'
remove_samples <- function(
  sce = NULL, min_nReads = NULL, max_nReads = NULL,
  min_nGenes = NULL, max_nGenes = NULL, min_percMT = NULL, max_percMT = NULL
){
  mat <- assay(sce, "counts")
  if(!((is.null(min_nReads)) || (is.null(max_nReads)))){
    inds_1 <- which((sce$nReads >= min_nReads) & (sce$nReads <= max_nReads))
  }else{
    inds_1 <- seq_len(dim(sce)[2])
  }
  if(!((is.null(min_nGenes)) || (is.null(max_nGenes)))){
    inds_2 <- which((sce$nGenes >= min_nGenes) & (sce$nGenes <= max_nGenes))
  }else{
    inds_2 <- seq_len(dim(sce)[2])
  }
  if(!((is.null(min_percMT)) || (is.null(max_percMT)))){
    inds_3 <- which((sce$percMT >= min_percMT) & (sce$percMT <= max_percMT))
  }else{
    inds_3 <- seq_len(dim(sce)[2])
  }
  inds <- intersect(intersect(inds_1, inds_2), inds_3)

  return(sce[, inds])
}
#-----------------------------------------------------------------------------80
#
#-----------------------------------------------------------------------------80
#' Remove variables based on the mean expression levels across samples.
#'
#' This function removes variable data such that the mean expression levels
#'   across samples are less than `min_meannReads`.
#'
#' @param sce A SingleCellExperiment object.
#' @param min_meannReads An integer. This function removes variables for which
#'   the mean read counts are less than this value.
#'
#' @return A SingleCellExperiment object.
#' @import SingleCellExperiment
#' @import SummarizedExperiment
#' @export
#'
#' @examples
#' data(pbmc_eg)
#' pbmc <- remove_variables_second(sce = pbmc_eg, min_meannReads = 0.01)
#'
remove_variables_second <- function(sce = NULL, min_meannReads = 0){
  mat <- assay(sce, "counts")
  inds <- which(apply(mat, 1, mean) >= min_meannReads)

  return(sce[inds, ])
}

#-----------------------------------------------------------------------------80
#
#-----------------------------------------------------------------------------80
#' Functional annotation-driven unsupervised clustering of SingleCell data.
#'
#' ASURAT is a software for single-cell data analysis.
#'    Using ASURAT, one can simultaneously perform unsupervised clustering and
#'    biological interpretation in terms of cell type, disease, biological
#'    process, and signaling pathway activity.
#'    Inputting a single-cell RNA-seq data and knowledge-based databases,
#'    such as Cell Ontology, Gene Ontology, KEGG, etc., ASURAT transforms
#'    gene expression tables into original multivariate tables, termed
#'    sign-by-sample matrices (SSMs).
#'
#' @docType package
#' @name ASURAT
NULL
#-----------------------------------------------------------------------------80
#
#-----------------------------------------------------------------------------80
#' @useDynLib ASURAT
#' @importFrom Rcpp sourceCpp
NULL

---
title: "ASURAT"
author: "Keita Iida"
date: "`r Sys.Date()`"
output:
  rmarkdown::html_vignette:
    toc: true
    toc_depth: 2
    number_section: true
    fig_width: 6
    fig_height: 5.4
vignette: >
  %\VignetteIndexEntry{ASURAT}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```



# Installations
Attach necessary libraries:
```{r, message = FALSE, warning = FALSE}
library(ASURAT)
library(SingleCellExperiment)
library(SummarizedExperiment)
```



<br>

# Goal
A goal of ASURAT is to cluster and characterize individual samples (cells)
in terms of cell type (or disease), biological function, signaling pathway
activity, and so on (see [here](#multilayered)).



<br>

# Quick start by SingleCellExperiment objects
Having a SingleCellExperiment object (e.g., `sce`), one can use ASURAT by
confirming the following requirements:

* `assays(sce)` contains gene expression data with row and column names as
  variable (gene) and sample (cell), respectively,

If `sce` contains normalized expression data (e.g., `assay(sce, "logcounts")`),
set `assay(sce, "centered")` by subtracting the data with the mean expression
levels across samples (cells).
```{r, eval = FALSE}
mat <- as.matrix(assay(sce, "logcounts"))
assay(sce, "centered") <- sweep(mat, 1, apply(mat, 1, mean), FUN = "-")
```

One may use a Seurat function `Seurat::as.SingleCellExperiment()` for converting
Seurat objects into SingleCellExperiment ones.

Now, ready for the next step [here](#sign).



<br>

# Preprocessing
## Prepare SingleCellExperiment objects
Load single-cell RNA sequencing (scRNA-seq) data.
```{r, message = FALSE}
sce <- TENxPBMCData::TENxPBMCData(dataset = c("pbmc4k"))
pbmc_counts <- as.matrix(assay(sce, "counts"))
rownames(pbmc_counts) <- make.unique(rowData(sce)$Symbol_TENx)
colnames(pbmc_counts) <- make.unique(colData(sce)$Barcode)
```
Here, `pbmc_counts` is a read count table of peripheral blood mononuclear cells
(PBMCs).

Below is a head of `pbmc_counts`:
```{r}
pbmc_counts[1:5, 1:3]
```

Create SingleCellExperiment objects by inputting gene expression data.
```{r}
pbmc <- SingleCellExperiment(assays = list(counts = pbmc_counts),
                             rowData = data.frame(gene = rownames(pbmc_counts)),
                             colData = data.frame(cell = colnames(pbmc_counts)))
```

Check data sizes.
```{r}
dim(pbmc)
```



<br>

## Control data quality
Remove variables (genes) and samples (cells) with low quality,
by processing the following three steps:

1. remove variables based on expression profiles across samples,
2. remove samples based on the numbers of reads and nonzero expressed variables,
3. remove variables based on the mean read counts across samples.

First of all, add metadata for both variables and samples using ASURAT function
`add_metadata()`.

The arguments are

* `sce`: SingleCellExperiment object, and
* `mitochondria_symbol`: a string representing for mitochondrial genes.
```{r}
pbmc <- add_metadata(sce = pbmc, mitochondria_symbol = "^MT-")
```
One can check the results in `rowData(sce)` and `colData(sce)` slots.



<br>

### Remove variables based on expression profiles
ASURAT function `remove_variables()` removes variable (gene) data such that
the numbers of non-zero expressing samples (cells) are less than `min_nsamples`.
```{r}
pbmc <- remove_variables(sce = pbmc, min_nsamples = 10)
```



<br>

### Remove samples based on expression profiles
Qualities of sample (cell) data are confirmed based on proper visualization of
`colData(sce)`.
```{r}
df <- data.frame(x = colData(pbmc)$nReads, y = colData(pbmc)$nGenes)
ggplot2::ggplot() +
  ggplot2::geom_point(ggplot2::aes(x = df$x, y = df$y), size = 1, alpha = 1) +
  ggplot2::labs(x = "Number of reads", y = "Number of genes") +
  ggplot2::theme_classic(base_size = 20)
```

```{r}
df <- data.frame(x = colData(pbmc)$nReads, y = colData(pbmc)$percMT)
ggplot2::ggplot() +
  ggplot2::geom_point(ggplot2::aes(x = df$x, y = df$y), size = 1, alpha = 1) +
  ggplot2::labs(x = "Number of reads", y = "Perc of MT reads") +
  ggplot2::theme_classic(base_size = 20)
```

ASURAT function `remove_samples()` removes sample (cell) data by setting cutoff
values for the metadata.

The arguments are

* `sce`: SingleCellExperiment object,
* `min_nReads` and `max_nReads`: minimum and maximum number of reads,
* `min_nGenes` and `max_nGenes`: minimum and maximum number of non-zero
expressed genes, and
* `min_percMT` and `max_percMT`: minimum and maximum percent of reads that
map to mitochondrial genes, respectively.
If there is no mitochondrial genes, set them as `NULL`.
```{r}
pbmc <- remove_samples(sce = pbmc, min_nReads = 5000, max_nReads = 20000,
                       min_nGenes = 100, max_nGenes = 1e+10,
                       min_percMT = 0, max_percMT = 10)
```
**Tips:**
Take care not to set excessive values for the arguments of `remove_samples()`,
or it may produce biased results.
Note that `min_nReads = 5000` is somewhat large, which is used only for the
tutorial.



<br>

### Remove variables based on the mean read counts
Qualities of variable (gene) data are confirmed based on proper visualization of
`rowData(sce)`.
```{r}
df <- data.frame(x = 1:nrow(rowData(pbmc)),
                 y = sort(rowData(pbmc)$nSamples, decreasing = TRUE))
ggplot2::ggplot() + ggplot2::scale_y_log10() +
  ggplot2::geom_point(ggplot2::aes(x = df$x, y = df$y), size = 1, alpha = 1) +
  ggplot2::labs(x = "Rank of genes", y = "Mean read counts") +
  ggplot2::theme_classic(base_size = 20)
```

ASURAT function `remove_variables_second()` removes variable (gene) data
such that the mean read counts across samples are less than `min_meannReads`.
```{r}
pbmc <- remove_variables_second(sce = pbmc, min_meannReads = 0.05)
```



<br>

## Normalize data
Normalize data using log transformation with a pseudo count and center the data
by subtracting with the mean expression levels across samples (cells).
The resulting normalized-and-centered data are used for downstream analyses.

Perform log-normalization with a pseudo count.
```{r}
assay(pbmc, "logcounts") <- log(assay(pbmc, "counts") + 1)
```

Center each row data.
```{r}
mat <- assay(pbmc, "logcounts")
assay(pbmc, "centered") <- sweep(mat, 1, apply(mat, 1, mean), FUN = "-")
```

Set gene expression data into `altExp(sce)`.

**Tips:**
Take care not to use a slot name "log-normalized" for `altExp(sce)`,
which may produce an error when using a Seurat (version 4.0.5) function
`as.Seurat()` in the downstream analysis.
```{r}
sname <- "logcounts"
altExp(pbmc, sname) <- SummarizedExperiment(list(counts = assay(pbmc, sname)))
```

Add ENTREZ Gene IDs to `rowData(sce)`.
```{r, message = FALSE}
dictionary <- AnnotationDbi::select(org.Hs.eg.db::org.Hs.eg.db,
                                    key = rownames(pbmc),
                                    columns = "ENTREZID", keytype = "SYMBOL")
dictionary <- dictionary[!duplicated(dictionary$SYMBOL), ]
rowData(pbmc)$geneID <- dictionary$ENTREZID
```



<br>

# Multifaceted sign analysis {#sign}
Infer cell or disease types, biological functions, and signaling pathway
activity at the single-cell level by inputting related databases.

ASURAT transforms centered read count tables to functional feature matrices,
termed sign-by-sample matrices (SSMs).
Using SSMs, perform unsupervised clustering of samples (cells).



<br>

## Compute correlation matrices
Prepare correlation matrices of gene expressions.
```{r}
set.seed(1)
nrand_samples <- 1000
mat <- t(as.matrix(assay(pbmc, "centered")))
ids <- sample(rownames(mat), nrand_samples, prob = NULL)
cormat <- cor(mat[ids, ], method = "spearman")
```



<br>

## Load databases
Load databases.
```{r}
urlpath <- "https://github.com/keita-iida/ASURATDB/blob/main/genes2bioterm/"
load(url(paste0(urlpath, "20201213_human_CO.rda?raw=TRUE")))         # CO
load(url(paste0(urlpath, "20220308_human_MSigDB.rda?raw=TRUE")))     # MSigDB
load(url(paste0(urlpath, "20201213_human_GO_red.rda?raw=TRUE")))     # GO
load(url(paste0(urlpath, "20201213_human_KEGG.rda?raw=TRUE")))       # KEGG
```
These knowledge-based data were available from the following repositories:

* [DOI:10.6084/m9.figshare.19102598](https://figshare.com/s/0599d2de970c2deb675c)
* [Github ASURATDB](https://github.com/keita-iida/ASURATDB)

Create a custom-built (CB) cell type-related database by combining different
databases for analyzing human single-cell transcriptome data.
```{r}
d <- list(human_CO[["cell"]], human_MSigDB[["cell"]])
res <- do.call("rbind", d)
human_CB <- list(cell = res)
```

Add formatted databases to `metadata(sce)$sign`.
```{r}
pbmcs <- list(CB = pbmc, GO = pbmc, KG = pbmc)
metadata(pbmcs$CB) <- list(sign = human_CB[["cell"]])
metadata(pbmcs$GO) <- list(sign = human_GO[["BP"]])
metadata(pbmcs$KG) <- list(sign = human_KEGG[["pathway"]])
```



<br>

## Create signs
ASURAT function `remove_signs()` redefines functional gene sets for the
input database by removing genes, which are not included in `rownames(sce)`,
and further removes biological terms including too few or too many genes.

The arguments are

* `sce`: SingleCellExperiment object,
* `min_ngenes`: minimal number of genes> 1 (the default value is 2), and
* `max_ngenes`: maximal number of genes> 1 (the default value is 1000).
```{r}
pbmcs$CB <- remove_signs(sce = pbmcs$CB, min_ngenes = 2, max_ngenes = 1000)
pbmcs$GO <- remove_signs(sce = pbmcs$GO, min_ngenes = 2, max_ngenes = 1000)
pbmcs$KG <- remove_signs(sce = pbmcs$KG, min_ngenes = 2, max_ngenes = 1000)
```
The results are stored in `metadata(sce)$sign`.

ASURAT function `cluster_genes()` clusters functional gene sets using
a correlation graph-based decomposition method, which produces strongly,
variably, and weakly correlated gene sets (SCG, VCG, and WCG, respectively).

The arguments are

* `sce`: SingleCellExperiment object,
* `cormat`: correlation matrix of gene expressions,
* `th_posi` and `th_nega`: threshold values of positive and negative
correlation coefficients, respectively.

**Tips:**
Empirically, typical values of `th_posi` and `th_nega` are
$0.15 \le {\rm th{\_}posi} \le 0.4$ and $-0.4 \le {\rm th{\_}nega} \le -0.15$,
but one cannot avoid trial and error for setting these values.
An exhaustive parameter searching is time-consuming but helpful for obtaining
interpretable results.
```{r}
set.seed(1)
pbmcs$CB <- cluster_genesets(sce = pbmcs$CB, cormat = cormat,
                             th_posi = 0.30, th_nega = -0.30)
set.seed(1)
pbmcs$GO <- cluster_genesets(sce = pbmcs$GO, cormat = cormat,
                             th_posi = 0.30, th_nega = -0.30)
set.seed(1)
pbmcs$KG <- cluster_genesets(sce = pbmcs$KG, cormat = cormat,
                             th_posi = 0.20, th_nega = -0.20)
```
The results are stored in `metadata(sce)$sign`.

ASURAT function `create_signs()` creates signs by the following criteria:

1. the number of genes in SCG>= `min_cnt_strg` (the default value is 2) and
2. the number of genes in VCG>= `min_cnt_vari` (the default value is 2),

which are independently applied to SCGs and VCGs, respectively.

**Tips:**
Empirically, typical values of `min_cnt_strg` and `min_cnt_vari` are
$2 \le {\rm min\_cnt\_strg} = {\rm min\_cnt\_vari} \le 4$,
but one cannot avoid trial and error for setting these values.
An exhaustive parameter searching is time-consuming but helpful for obtaining
interpretable results.
```{r}
pbmcs$CB <- create_signs(sce = pbmcs$CB, min_cnt_strg = 2, min_cnt_vari = 2)
pbmcs$GO <- create_signs(sce = pbmcs$GO, min_cnt_strg = 4, min_cnt_vari = 4)
pbmcs$KG <- create_signs(sce = pbmcs$KG, min_cnt_strg = 3, min_cnt_vari = 3)
```
The results are stored in `metadata(sce)$sign_all`,
where "CorrType" indicates SCG or VCG, "Corr" means the average correlation
coefficients of SCG or VCG, "CorrWeak" means the average correlation
coefficients of WCG, "CorrGene" means SCG or VCG, and "WeakCorrGene" means WCG.
The orders of gene symbols and ENTREZ IDs, separated by "/", are consistent.

**Tips:**
If one would like to recreate signs, reset the list of objects by, e.g.,
(`pbmcs <- list(CB = pbmc, GO = pbmc, KG = pbmc)`), and go back to
`remove_signs()`.



<br>

## Select signs
If signs have semantic similarity information, one can use ASURAT function
`remove_signs_redundant()` for removing redundant sings using the semantic
similarity matrices.

The arguments are

* `sce`: SingleCellExperiment object,
* `similarity_matrix`: a semantic similarity matrix,
* `threshold`: a threshold value of semantic similarity, used for regarding
biological terms as similar ones, and
* `keep_rareID`: if `TRUE`, biological terms with the larger ICs are kept.

**Tips:**
The optimal value of `threshold` depends on the ontology structure as well as
the method for computing semantic similarity matrix.
```{r}
pbmcs$GO <- remove_signs_redundant(sce = pbmcs$GO,
                                   similarity_matrix = human_GO$similarity_matrix$BP,
                                   threshold = 0.70, keep_rareID = TRUE)
```
The results are stored in `metadata(sce)$sign_SCG`, `metadata(sce)$sign_VCG`,
`metadata(sce)$sign_all`, and if there exist, `metadata(sce)$sign_SCG_redundant`
and `metadata(sce)$sign_VCG_redundant`.

ASURAT function `remove_signs_manually()` removes signs by specifying
IDs (e.g., `GOID:XXX`) or descriptions (e.g., `COVID`) using `grepl()`.
The arguments are `sce` and `keywords` (keywords separated by `|`).
```{r}
keywords <- "Covid|COVID"
pbmcs$KG <- remove_signs_manually(sce = pbmcs$KG, keywords = keywords)
```
The results are stored in `metadata(sce)$sign_SCG`, `metadata(sce)$sign_VCG`,
and `metadata(sce)$sign_all`.

There is another ASURAT function `select_signs_manually()`, a counter part of
`remove_signs_manually()`, which removes signs that do not include `keywords`
(keywords separated by `|`).
```{r, eval = FALSE}
keywords <- "cell|cyte"
test <- select_signs_manually(sce = pbmcs$CB, keywords = keywords)
```
The results are stored in `metadata(sce)$sign_SCG`, `metadata(sce)$sign_VCG`,
and `metadata(sce)$sign_all`.



<br>

## Create sign-by-sample matrices
ASURAT function `create_sce_signmatrix()` creates a new SingleCellExperiment
object `new_sce`, consisting of the following information:

* `assayNames(new_sce)`: counts (SSM whose entries are termed sign scores),
* `names(colData(new_sce))`: nReads, nGenes, percMT,
* `names(rowData(new_sce))`: ParentSignID, Description, CorrGene, etc.,
* `names(metadata(new_sce))`: sign_SCG, sign_VCG, etc.,
* `altExpNames(new_sce)`: something if there is data in `altExp(sce)`.

The arguments are

* `sce`: SingleCellExperiment object,
* `weight_strg`: weight parameter for SCG (the default value is 0.5), and
* `weight_vari`: weight parameter for VCG (the default is 0.5).
```{r}
pbmcs$CB <- makeSignMatrix(sce = pbmcs$CB, weight_strg = 0.5, weight_vari = 0.5)
pbmcs$GO <- makeSignMatrix(sce = pbmcs$GO, weight_strg = 0.5, weight_vari = 0.5)
pbmcs$KG <- makeSignMatrix(sce = pbmcs$KG, weight_strg = 0.5, weight_vari = 0.5)
```

Below are head and tail of `assay(sce, "counts")`:
```{r}
rbind(head(assay(pbmcs$CB, "counts")[, 1:3], n = 4),
      tail(assay(pbmcs$CB, "counts")[, 1:3], n = 4))
```



<br>

## Reduce dimensions of sign-by-sample matrices
Perform principal component analysis and t-distributed stochastic neighbor
embedding (t-SNE).
```{r}
pca_dims <- c(30, 30, 50)
tsne_dims <- c(2, 2, 3)
for(i in seq_along(pbmcs)){
  set.seed(1)
  mat <- t(as.matrix(assay(pbmcs[[i]], "counts")))
  res <- Rtsne::Rtsne(mat, dim = tsne_dims[i], pca = TRUE,
                      initial_dims = pca_dims[i])
  reducedDim(pbmcs[[i]], "TSNE") <- res[["Y"]]
}
```

Show the results of dimensional reduction in t-SNE spaces.
```{r}
df <- as.data.frame(reducedDim(pbmcs$CB, "TSNE"))
ggplot2::ggplot() + ggplot2::geom_point(ggplot2::aes(x = df[, 1], y = df[, 2]),
                                        color = "black", size = 1, alpha = 1) +
  ggplot2::labs(title = "PBMC (cell type)", x = "tSNE_1", y = "tSNE_2") +
  ggplot2::theme_classic(base_size = 15)
```

```{r}
df <- as.data.frame(reducedDim(pbmcs$GO, "TSNE"))
ggplot2::ggplot() + ggplot2::geom_point(ggplot2::aes(x = df[, 1], y = df[, 2]),
                                        color = "black", size = 1, alpha = 1) +
  ggplot2::labs(title = "PBMC (function)", x = "tSNE_1", y = "tSNE_2") +
  ggplot2::theme_classic(base_size = 15)
```

Use ASURAT function `plot_dataframe3D()` for plotting three-dimensional data.
See `?plot_dataframe3D` for details.
```{r}
df <- as.data.frame(reducedDim(pbmcs$KG, "TSNE"))
plot_dataframe3D(dataframe3D = df, theta = 45, phi = 30, title = "PBMC (pathway)",
                 xlabel = "tSNE_1", ylabel = "tSNE_2", zlabel = "tSNE_3")
```



<br>

## Cluster cells
### Use Seurat functions
To date (December, 2021), one of the most useful clustering methods in scRNA-seq
data analysis is a combination of a community detection algorithm and
graph-based unsupervised clustering, developed in Seurat package.

Here, our strategy is as follows:

1. convert SingleCellExperiment objects into Seurat objects
  (note that `rowData()` and `colData()` must have data),
2. perform `ScaleData()`, `RunPCA()`, `FindNeighbors()`, and `FindClusters()`,
3. convert Seurat objects into temporal SingleCellExperiment objects `temp`,
4. add `colData(temp)$seurat_clusters` into `colData(sce)$seurat_clusters`.
```{r, message = FALSE, warning = FALSE, results = "hide"}
resolutions <- c(0.20, 0.20, 0.10)
ds <- list(seq_len(20), seq_len(20), seq_len(20))
for(i in seq_along(pbmcs)){
  surt <- Seurat::as.Seurat(pbmcs[[i]], counts = "counts", data = "counts")
  mat <- as.matrix(assay(pbmcs[[i]], "counts"))
  surt[["SSM"]] <- Seurat::CreateAssayObject(counts = mat)
  Seurat::DefaultAssay(surt) <- "SSM"
  surt <- Seurat::ScaleData(surt, features = rownames(surt))
  surt <- Seurat::RunPCA(surt, features = rownames(surt))
  surt <- Seurat::FindNeighbors(surt, reduction = "pca", dims = ds[[i]])
  surt <- Seurat::FindClusters(surt, resolution = resolutions[i])
  temp <- Seurat::as.SingleCellExperiment(surt)
  colData(pbmcs[[i]])$seurat_clusters <- colData(temp)$seurat_clusters
}
```

Show the clustering results in t-SNE spaces.
```{r}
labels <- colData(pbmcs$CB)$seurat_clusters
df <- as.data.frame(reducedDim(pbmcs$CB, "TSNE"))
ggplot2::ggplot() +
  ggplot2::geom_point(ggplot2::aes(x = df[, 1], y = df[, 2], color = labels),
                      size = 1, alpha = 1) +
  ggplot2::labs(title = "PBMC (cell type)", x = "tSNE_1", y = "tSNE_2", color = "") +
  ggplot2::theme_classic(base_size = 15) + ggplot2::scale_colour_hue() +
  ggplot2::guides(colour = ggplot2::guide_legend(override.aes = list(size = 4)))
```

```{r}
labels <- colData(pbmcs$GO)$seurat_clusters
df <- as.data.frame(reducedDim(pbmcs$GO, "TSNE"))
ggplot2::ggplot() +
  ggplot2::geom_point(ggplot2::aes(x = df[, 1], y = df[, 2], color = labels),
                      size = 1, alpha = 1) +
  ggplot2::labs(title = "PBMC (function)", x = "tSNE_1", y = "tSNE_2", color = "") +
  ggplot2::theme_classic(base_size = 15) +
  ggplot2::scale_colour_brewer(palette = "Set1") +
  ggplot2::guides(colour = ggplot2::guide_legend(override.aes = list(size = 4)))
```

Use ASURAT function `plot_dataframe3D()` for plotting three-dimensional data.
See `?plot_dataframe3D` for details.
```{r}
labels <- colData(pbmcs$KG)$seurat_clusters
colors <- scales::brewer_pal(palette = "Set2")(length(unique(labels)))[labels]
df <- as.data.frame(reducedDim(pbmcs$KG, "TSNE")[, seq_len(3)])
plot_dataframe3D(dataframe3D = df, labels = labels, colors = colors,
                 theta = 45, phi = 30, title = "PBMC (pathway)",
                 xlabel = "tSNE_1", ylabel = "tSNE_2", zlabel = "tSNE_3")
```



<br>

### Cell cycle inference using Seurat functions
If there is gene expression data in `altExp(sce)`, one can infer cell cycle
phases by using Seurat functions in the similar manner as above.
```{r, message = FALSE, warning = FALSE}
surt <- Seurat::as.Seurat(pbmcs$CB, counts = "counts", data = "counts")
mat <- as.matrix(assay(altExp(pbmcs$CB), "counts"))
surt[["GEM"]] <- Seurat::CreateAssayObject(counts = mat)
Seurat::DefaultAssay(surt) <- "GEM"
surt <- Seurat::ScaleData(surt, features = rownames(surt))
surt <- Seurat::RunPCA(surt, features = rownames(surt))
surt <- Seurat::CellCycleScoring(surt, s.features = Seurat::cc.genes$s.genes,
                                 g2m.features = Seurat::cc.genes$g2m.genes)
temp <- Seurat::as.SingleCellExperiment(surt)
colData(pbmcs$CB)$Phase <- colData(temp)$Phase
```



<br>

## Investigate significant signs
Significant signs are analogous to differentially expressed genes but bear
biological meanings.
Note that naïve usages of statistical tests should be avoided because the row
vectors of SSMs are centered.

Instead, ASURAT function `compute_sepI_all()` computes separation indices
for each cluster against the others.
Briefly, a separation index "sepI", ranging from -1 to 1, is a nonparametric
measure of significance of a given sign score for a given subpopulation.
The larger (resp. smaller) sepI is, the more reliable the sign is as a positive
(resp. negative) marker for the cluster.

The arguments are

* `sce`: SingleCellExperiment object,
* `labels`: a vector of labels of all the samples, and
* `nrand_samples`: an integer for the number of samples used for random
  sampling, which samples at least one sample per cluster.
```{r, message = FALSE, results = "hide"}
for(i in seq_along(pbmcs)){
  set.seed(1)
  labels <- colData(pbmcs[[i]])$seurat_clusters
  pbmcs[[i]] <- compute_sepI_all(sce = pbmcs[[i]], labels = labels,
                                 nrand_samples = 200)
}
```
The results are stored in `metadata(sce)$marker_signs`.

When computing separation indices between given clusters, e.g., cluster 1 versus
clusters 2 and 3, use an ASURAT function `compute_sepI_clusters()`.
See `?compute_sepI_clusters` for details.



<br>

## Investigate significant genes
### Use Seurat function
To date (December, 2021), one of the most useful methods of multiple statistical
tests in scRNA-seq data analysis is to use a Seurat function `FindAllMarkers()`.

If there is gene expression data in `altExp(sce)`, one can investigate
differentially expressed genes by using Seurat functions in the similar manner
as described before.
```{r, message = FALSE}
set.seed(1)
surt <- Seurat::as.Seurat(pbmcs$CB, counts = "counts", data = "counts")
mat <- as.matrix(assay(altExp(pbmcs$CB), "counts"))
surt[["GEM"]] <- Seurat::CreateAssayObject(counts = mat)
Seurat::DefaultAssay(surt) <- "GEM"
surt <- Seurat::SetIdent(surt, value = "seurat_clusters")
res <- Seurat::FindAllMarkers(surt, only.pos = TRUE,
                              min.pct = 0.50, logfc.threshold = 0.50)
metadata(pbmcs$CB)$marker_genes$all <- res
```



<br>

## Multifaceted analysis {#multilayered}
Simultaneously analyze multiple sign-by-sample matrices, which helps us
characterize individual samples (cells) from multiple biological aspects.

ASURAT function `plot_multiheatmaps()` shows heatmaps (ComplexHeatmap object)
of sign scores and gene expression levels (if there are), where rows and columns
stand for sign (or gene) and sample (cell), respectively.
See `?plot_multiheatmaps` for details.

First, remove unrelated signs by setting keywords, followed by selecting top
significant signs and genes for the clustering results with respect to
separation index and adjusted p-value, respectively.
```{r}
# Significant signs
marker_signs <- list()
keywords <- "MESENCHYMAL|LIMB|PANCREAS"
for(i in seq_along(pbmcs)){
  marker_signs[[i]] <- metadata(pbmcs[[i]])$marker_signs$all
  marker_signs[[i]] <-
    marker_signs[[i]][!grepl(keywords, marker_signs[[i]]$Description), ]
  marker_signs[[i]] <- dplyr::group_by(marker_signs[[i]], Ident_1)
  marker_signs[[i]] <- dplyr::slice_max(marker_signs[[i]], sepI, n = 2)
  marker_signs[[i]] <- dplyr::slice_min(marker_signs[[i]], Rank, n = 1)
}
# Significant genes
marker_genes_CB <- metadata(pbmcs$CB)$marker_genes$all
marker_genes_CB <- dplyr::group_by(marker_genes_CB, cluster)
marker_genes_CB <- dplyr::slice_min(marker_genes_CB, p_val_adj, n = 2)
marker_genes_CB <- dplyr::slice_max(marker_genes_CB, avg_log2FC, n = 1)
```

Next, prepare the arguments.
```{r}
# ssm_list
sces_sub <- list() ; ssm_list <- list()
for(i in seq_along(pbmcs)){
  sces_sub[[i]] <- pbmcs[[i]][rownames(pbmcs[[i]]) %in% marker_signs[[i]]$SignID, ]
  ssm_list[[i]] <- assay(sces_sub[[i]], "counts")
}
names(ssm_list) <- c("SSM_cell", "SSM_function", "SSM_pathway")
# gem_list
expr_sub <- altExp(pbmcs$CB, "logcounts")
expr_sub <- expr_sub[rownames(expr_sub) %in% marker_genes_CB$gene]
gem_list <- list(GeneExpr = assay(expr_sub, "counts"))
# ssmlabel_list
labels <- list() ; ssmlabel_list <- list()
for(i in seq_along(pbmcs)){
  tmp <- colData(sces_sub[[i]])$seurat_clusters
  labels[[i]] <- data.frame(label = tmp)
  n_groups <- length(unique(tmp))
  if(i == 1){
    labels[[i]]$color <- scales::hue_pal()(n_groups)[tmp]
  }else if(i == 2){
    labels[[i]]$color <- scales::brewer_pal(palette = "Set1")(n_groups)[tmp]
  }else if(i == 3){
    labels[[i]]$color <- scales::brewer_pal(palette = "Set2")(n_groups)[tmp]
  }
  ssmlabel_list[[i]] <- labels[[i]]
}
names(ssmlabel_list) <- c("Label_cell", "Label_function", "Label_pathway")
# gemlabel_list
label_CC <- data.frame(label = colData(pbmcs$CB)$Phase, color = NA)
gemlabel_list <- list(CellCycle = label_CC)
```

Show heatmaps for the selected signs and genes.
```{r, message = FALSE, warning = FALSE}
set.seed(1)
plot_multiheatmaps(ssm_list = ssm_list, gem_list = gem_list,
                   ssmlabel_list = ssmlabel_list, gemlabel_list = gemlabel_list,
                   nrand_samples = 100, show_row_names = TRUE, title = "PBMC")
```

Show violin plots for sign score distributions across cell type-related clusters.
```{r}
labels <- colData(pbmcs$CB)$seurat_clusters
variable <- "GO:0042100-V"
description <- "B cell proliferation"
subsce <- pbmcs$GO[which(rownames(pbmcs$GO) == variable), ]
df <- as.data.frame(t(as.matrix(assay(subsce, "counts"))))
ggplot2::ggplot() +
  ggplot2::geom_violin(ggplot2::aes(x = as.factor(labels), y = df[, 1],
                                    fill = labels), trim = FALSE, size = 0.5) +
  ggplot2::geom_boxplot(ggplot2::aes(x = as.factor(labels), y = df[, 1]),
                        width = 0.15, alpha = 0.6) +
  ggplot2::labs(title = paste0(variable, "\n", description),
                x = "Cluster (cell type)", y = "Sign score") +
  ggplot2::theme_classic(base_size = 20) +
  ggplot2::theme(legend.position = "none") + ggplot2::scale_fill_hue()
```

Show violin plots for gene expression distributions across cell type-related
clusters.
```{r}
vname <- "CD79A"
sub <- altExp(pbmcs$CB, "logcounts")
sub <- sub[rownames(sub) == vname, ]
labels <- colData(pbmcs$CB)$seurat_clusters
df <- as.data.frame(t(assay(sub, "counts")))
ggplot2::ggplot() +
  ggplot2::geom_violin(ggplot2::aes(x = as.factor(labels), y = df[, 1],
                                    fill = labels), trim = FALSE, size = 0.5) +
  ggplot2::geom_boxplot(ggplot2::aes(x = as.factor(labels), y = df[, 1]),
                        width = 0.15, alpha = 0.6) +
  ggplot2::labs(title = vname, x = "Cluster (cell type)",
                y = "Normalized expression") +
  ggplot2::theme_classic(base_size = 20) +
  ggplot2::theme(legend.position = "none") + ggplot2::scale_fill_hue()
```



<br>

# Session information

```{r}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/create_signs.R
\name{remove_signs}
\alias{remove_signs}
\title{Remove signs including too few or too many genes.}
\usage{
remove_signs(sce = NULL, min_ngenes = 2, max_ngenes = 1000)
}
\arguments{
\item{sce}{A SingleCellExperiment object.}

\item{min_ngenes}{Minimum number of genes, which must be greater than one.}

\item{max_ngenes}{Maximum number of genes, which must be greater than one.}
}
\value{
A SingleCellExperiment object.
}
\description{
This function removes signs including too few or too many genes.
}
\examples{
data(pbmc_eg)
data(human_GO_eg)
pbmcs <- list(GO = pbmc_eg)
S4Vectors::metadata(pbmcs$GO) <- list(sign = human_GO_eg[["BP"]])
pbmcs$GO <- remove_signs(sce = pbmcs$GO, min_ngenes = 2, max_ngenes = 1000)
# The results are stored in `metadata(pbmcs$GO)$sign`.

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/preprocess.R
\name{remove_variables}
\alias{remove_variables}
\title{Remove variables based on expression profiles across samples.}
\usage{
remove_variables(sce = NULL, min_nsamples = 0)
}
\arguments{
\item{sce}{A SingleCellExperiment object.}

\item{min_nsamples}{An integer. This function removes variables for which
the numbers of non-zero expressing samples are less than this value.}
}
\value{
A SingleCellExperiment object.
}
\description{
This function removes low expressed variable data.
}
\examples{
data(pbmc_eg)
pbmc <- add_metadata(sce = pbmc_eg, mitochondria_symbol = "^MT-")
pbmc <- remove_variables(sce = pbmc, min_nsamples = 10)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ASURAT.R
\docType{package}
\name{ASURAT}
\alias{ASURAT}
\title{Functional annotation-driven unsupervised clustering of SingleCell data.}
\description{
ASURAT is a software for single-cell data analysis.
   Using ASURAT, one can simultaneously perform unsupervised clustering and
   biological interpretation in terms of cell type, disease, biological
   process, and signaling pathway activity.
   Inputting a single-cell RNA-seq data and knowledge-based databases,
   such as Cell Ontology, Gene Ontology, KEGG, etc., ASURAT transforms
   gene expression tables into original multivariate tables, termed
   sign-by-sample matrices (SSMs).
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/create_signs.R
\name{makeSignMatrix}
\alias{makeSignMatrix}
\title{Create a new SingleCellExperiment object for sign-by-sample matrices.}
\usage{
makeSignMatrix(sce = NULL, weight_strg = 0.5, weight_vari = 0.5)
}
\arguments{
\item{sce}{A SingleCellExperiment object.}

\item{weight_strg}{A weight parameter for strongly correlated gene sets.}

\item{weight_vari}{A weight parameter for variably correlated gene sets.}
}
\value{
A SingleCellExperiment object.
}
\description{
This function creates a new SingleCellExperiment object for sign-by-sample
  matrices (SSM) by concatenating SSMs for strongly and variably correlated
  gene sets.
}
\examples{
data(pbmc_eg)
data(human_GO_eg)
mat <- t(as.matrix(SummarizedExperiment::assay(pbmc_eg, "centered")))
pbmc_cormat <- cor(mat, method = "spearman")
pbmcs <- list(GO = pbmc_eg)
S4Vectors::metadata(pbmcs$GO) <- list(sign = human_GO_eg[["BP"]])
pbmcs$GO <- remove_signs(sce = pbmcs$GO, min_ngenes = 2, max_ngenes = 1000)
pbmcs$GO <- cluster_genesets(sce = pbmcs$GO, cormat = pbmc_cormat,
                             th_posi = 0.24, th_nega = -0.20)
pbmcs$GO <- create_signs(sce = pbmcs$GO, min_cnt_strg = 2, min_cnt_vari = 2)
pbmcs$GO <- makeSignMatrix(sce = pbmcs$GO, weight_strg = 0.5,
                           weight_vari = 0.5)
# The resutls can be check by, e.g., assay(pbmcs$GO, "counts").

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{pbmcs_eg}
\alias{pbmcs_eg}
\title{A list of SingleCellExperiment objects made from sign-sample matrices.}
\format{
A list of SingleCellExperiment objects.
}
\usage{
pbmcs_eg
}
\description{
A list of SingleCellExperiment objects, consisting of small sign-by-sample
  matrices, pbmcs_eg$CM (using Cell Ontology and MSigDB databases),
  pbmcs_eg$GO (using Gene Ontology database), and pbmcs_eg$KG (KEGG).
  Here, pbmcs_eg$CM, pbmcs_eg$GO, and pbmcs_eg$KG include 87, 72, and 64
  signs, respectively, and 50 cells.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{human_KEGG_eg}
\alias{human_KEGG_eg}
\title{A list of small KEGG database for human.}
\format{
A list of dataframe.
}
\usage{
human_KEGG_eg
}
\description{
A list of small KEGG database for human.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/find_marker_signs.R
\name{compute_sepI_all}
\alias{compute_sepI_all}
\title{Compute separation indices for each cluster against the others.}
\usage{
compute_sepI_all(sce = NULL, labels = NULL, nrand_samples = NULL)
}
\arguments{
\item{sce}{A SingleCellExperiment object.}

\item{labels}{A vector of labels of all the samples (cells).}

\item{nrand_samples}{An integer for the number of samples used for
random sampling, which samples at least one sample per cluster.}
}
\value{
A SingleCellExperiment object.
}
\description{
This function computes separation indices for each cluster versus the others.
}
\examples{
data(pbmcs_eg)
labels <- SummarizedExperiment::colData(pbmcs_eg$GO)$seurat_clusters
pbmcs_eg$GO <- compute_sepI_all(sce = pbmcs_eg$GO, labels = labels,
                                nrand_samples = 10)
# The results are stored in `metadata(pbmcs_eg$GO)$marker_signs`.

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/create_signs.R
\name{create_signs}
\alias{create_signs}
\title{Define signs for strongly and variably correlated gene sets.}
\usage{
create_signs(sce = NULL, min_cnt_strg = 2, min_cnt_vari = 2)
}
\arguments{
\item{sce}{A SingleCellExperiment object.}

\item{min_cnt_strg}{An integer for the cutoff value for strongly correlated
gene sets.}

\item{min_cnt_vari}{An integer for the cutoff value for variably correlated
gene sets.}
}
\value{
A SingleCellExperiment object.
}
\description{
This function define signs for strongly and variably correlated gene sets.
}
\examples{
data(pbmc_eg)
data(human_GO_eg)
mat <- t(as.matrix(SummarizedExperiment::assay(pbmc_eg, "centered")))
pbmc_cormat <- cor(mat, method = "spearman")
pbmcs <- list(GO = pbmc_eg)
S4Vectors::metadata(pbmcs$GO) <- list(sign = human_GO_eg[["BP"]])
pbmcs$GO <- remove_signs(sce = pbmcs$GO, min_ngenes = 2, max_ngenes = 1000)
pbmcs$GO <- cluster_genesets(sce = pbmcs$GO, cormat = pbmc_cormat,
                             th_posi = 0.24, th_nega = -0.20)
pbmcs$GO <- create_signs(sce = pbmcs$GO, min_cnt_strg = 2, min_cnt_vari = 2)
# The results are stored in `metadata(pbmcs$GO)$sign_all`.

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{bubble_sort}
\alias{bubble_sort}
\title{Perform bubble sorting, counting the number of steps.}
\usage{
bubble_sort(listdata)
}
\arguments{
\item{listdata}{A list of vector and integer.
For example, in R code, listdata = list(vec = c(1, 0, 1, ...), cnt = 0).
The integer (cnt = 0) is the initial number of steps for bubble sorting.}
}
\value{
A List.
}
\description{
Perform bubble sorting, counting the number of steps.
}
\examples{
bubble_sort(list(vec = c(1, 1, 0), cnt = 0))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/create_signs.R
\name{remove_signs_manually}
\alias{remove_signs_manually}
\title{Remove signs by specifying keywords.}
\usage{
remove_signs_manually(sce = NULL, keywords = NULL)
}
\arguments{
\item{sce}{A SingleCellExperiment object.}

\item{keywords}{keywords separated by pipes `|`.}
}
\value{
A SingleCellExperiment object.
}
\description{
This function removes signs by specifying keywords.
}
\examples{
data(pbmc_eg)
data(human_GO_eg)
mat <- t(as.matrix(SummarizedExperiment::assay(pbmc_eg, "centered")))
pbmc_cormat <- cor(mat, method = "spearman")
pbmcs <- list(GO = pbmc_eg)
S4Vectors::metadata(pbmcs$GO) <- list(sign = human_GO_eg[["BP"]])
pbmcs$GO <- remove_signs(sce = pbmcs$GO, min_ngenes = 2, max_ngenes = 1000)
pbmcs$GO <- cluster_genesets(sce = pbmcs$GO, cormat = pbmc_cormat,
                             th_posi = 0.24, th_nega = -0.20)
pbmcs$GO <- create_signs(sce = pbmcs$GO, min_cnt_strg = 2, min_cnt_vari = 2)
keywords <- "Covid19|foofoo|hogehoge"
pbmcs$GO <- remove_signs_manually(sce = pbmcs$GO, keywords = keywords)
# The results are stored in `metadata(pbmcs$GO)$sign_SCG`,
# `metadata(pbmcs$GO)$sign_VCG`, and `metadata(pbmcs$GO)$sign_all`.

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{swap_pass}
\alias{swap_pass}
\title{Perform one-shot adjacent swapping for each element.}
\usage{
swap_pass(listdata)
}
\arguments{
\item{listdata}{A list of vector and integer.}
}
\value{
A List.
}
\description{
Perform one-shot adjacent swapping for each element.
}
\examples{
swap_pass(list(vec = c(1, 1, 0), cnt = 0))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/preprocess.R
\name{add_metadata}
\alias{add_metadata}
\title{Add metadata of variables and samples.}
\usage{
add_metadata(sce = NULL, mitochondria_symbol = NULL)
}
\arguments{
\item{sce}{A SingleCellExperiment object.}

\item{mitochondria_symbol}{A string representing for mitochondrial genes.
This function computes percents of reads that map to the mitochondrial
genes. Examples are `^MT-`, `^mt-`, etc.}
}
\value{
A SingleCellExperiment object.
}
\description{
This function adds metadata of variables and samples.
}
\examples{
data(pbmc_eg)
pbmc <- add_metadata(sce = pbmc_eg, mitochondria_symbol = "^MT-")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{pbmc_eg}
\alias{pbmc_eg}
\title{A SingleCellExperiment object made from a gene expression table.}
\format{
SingleCellExperiment object.
}
\source{
\url{https://support.10xgenomics.com/single-cell-gene-expression}
}
\usage{
pbmc_eg
}
\description{
A SingleCellExperiment object, including 50 genes and 50 cells.
  The original data "4k PBMCs from a Healthy Donor" was downloaded from 10x
  Genomics database.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/preprocess.R
\name{remove_variables_second}
\alias{remove_variables_second}
\title{Remove variables based on the mean expression levels across samples.}
\usage{
remove_variables_second(sce = NULL, min_meannReads = 0)
}
\arguments{
\item{sce}{A SingleCellExperiment object.}

\item{min_meannReads}{An integer. This function removes variables for which
the mean read counts are less than this value.}
}
\value{
A SingleCellExperiment object.
}
\description{
This function removes variable data such that the mean expression levels
  across samples are less than `min_meannReads`.
}
\examples{
data(pbmc_eg)
pbmc <- remove_variables_second(sce = pbmc_eg, min_meannReads = 0.01)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot.R
\name{plot_dataframe3D}
\alias{plot_dataframe3D}
\title{Visualize a three-dimensional data with labels and colors.}
\usage{
plot_dataframe3D(
  dataframe3D = NULL,
  labels = NULL,
  colors = NULL,
  theta = 30,
  phi = 30,
  title = "",
  xlabel = "",
  ylabel = "",
  zlabel = ""
)
}
\arguments{
\item{dataframe3D}{A dataframe with three columns.}

\item{labels}{NULL or a vector of labels of all the samples,
corresponding to colors.}

\item{colors}{NULL or a vector of colors of all the samples,
corresponding to labels.}

\item{theta}{Angle of the plot.}

\item{phi}{Angle of the plot.}

\item{title}{Title.}

\item{xlabel}{x-axis label.}

\item{ylabel}{y-axis label.}

\item{zlabel}{z-axis label.}
}
\value{
A scatter3D object in plot3D package.
}
\description{
This function visualizes a three-dimensional data with labels and colors.
}
\examples{
data(pbmcs_eg)
mat <- SingleCellExperiment::reducedDim(pbmcs_eg$CM, "UMAP")[, 1:3]
dataframe3D <- as.data.frame(mat)
labels <- SummarizedExperiment::colData(pbmcs_eg$CM)$seurat_clusters
plot_dataframe3D(dataframe3D = dataframe3D, labels = labels, colors = NULL,
                 theta = 45, phi = 20, title = "PBMC (CO & MSigDB)",
                 xlabel = "UMAP_1", ylabel = "UMAP_2", zlabel = "UMAP_3")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/preprocess.R
\name{remove_samples}
\alias{remove_samples}
\title{Remove samples based on expression profiles across variables.}
\usage{
remove_samples(
  sce = NULL,
  min_nReads = NULL,
  max_nReads = NULL,
  min_nGenes = NULL,
  max_nGenes = NULL,
  min_percMT = NULL,
  max_percMT = NULL
)
}
\arguments{
\item{sce}{A SingleCellExperiment object.}

\item{min_nReads}{A minimum threshold value of the number of reads.}

\item{max_nReads}{A maximum threshold value of the number of reads.}

\item{min_nGenes}{A minimum threshold value of the number of non-zero
expressed genes.}

\item{max_nGenes}{A maximum threshold value of the number of non-zero
expressed genes.}

\item{min_percMT}{A minimum threshold value of the percent of reads that map
to mitochondrial genes.}

\item{max_percMT}{A maximum threshold value of the percent of reads that map
to mitochondrial genes.}
}
\value{
A SingleCellExperiment object.
}
\description{
This function removes sample data by setting minimum and maximum threshold
  values for the metadata.
}
\examples{
data(pbmc_eg)
pbmc <- add_metadata(sce = pbmc_eg, mitochondria_symbol = "^MT-")
pbmc <- remove_samples(sce = pbmc, min_nReads = 0, max_nReads = 1e+10,
                       min_nGenes = 0, max_nGenes = 1e+10,
                       min_percMT = NULL, max_percMT = NULL)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/create_signs.R
\name{remove_signs_redundant}
\alias{remove_signs_redundant}
\title{Remove redundant signs using semantic similarity matrices.}
\usage{
remove_signs_redundant(
  sce = NULL,
  similarity_matrix = NULL,
  threshold = NULL,
  keep_rareID = NULL
)
}
\arguments{
\item{sce}{A SingleCellExperiment object.}

\item{similarity_matrix}{A semantic similarity matrix.}

\item{threshold}{A threshold value of semantic similarity, used for
regarding biological terms as similar ones}

\item{keep_rareID}{If TRUE, biological terms with the larger ICs are kept.}
}
\value{
A SingleCellExperiment object.
}
\description{
This function removes redundant signs using semantic similarity matrices.
}
\examples{
data(pbmc_eg)
data(human_GO_eg)
mat <- t(as.matrix(SummarizedExperiment::assay(pbmc_eg, "centered")))
pbmc_cormat <- cor(mat, method = "spearman")
pbmcs <- list(GO = pbmc_eg)
S4Vectors::metadata(pbmcs$GO) <- list(sign = human_GO_eg[["BP"]])
pbmcs$GO <- remove_signs(sce = pbmcs$GO, min_ngenes = 2, max_ngenes = 1000)
pbmcs$GO <- cluster_genesets(sce = pbmcs$GO, cormat = pbmc_cormat,
                             th_posi = 0.24, th_nega = -0.20)
pbmcs$GO <- create_signs(sce = pbmcs$GO, min_cnt_strg = 2, min_cnt_vari = 2)
pbmcs$GO <- remove_signs_redundant(
  sce = pbmcs$GO, similarity_matrix = human_GO_eg$similarity_matrix$BP,
  threshold = 0.80, keep_rareID = TRUE)
# The results are stored in `metadata(pbmcs$GO)$sign_SCG`,
# `metadata(pbmcs$GO)$sign_VCG`, `metadata(pbmcs$GO)$sign_all`,
# and if there exist, `metadata(pbmcs$GO)$sign_SCG_redundant` and
# `metadata(pbmcs$GO)$sign_VCG_redundant`.

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot.R
\name{plot_multiheatmaps}
\alias{plot_multiheatmaps}
\title{Visualize multivariate data by heatmaps.}
\usage{
plot_multiheatmaps(
  ssm_list = NULL,
  gem_list = NULL,
  ssmlabel_list = NULL,
  gemlabel_list = NULL,
  nrand_samples = NULL,
  show_row_names = FALSE,
  title = NULL
)
}
\arguments{
\item{ssm_list}{A list of sign-by-sample matrices.}

\item{gem_list}{A list of gene-by-sample matrices.}

\item{ssmlabel_list}{NULL or a list of dataframes of sample (cell)
labels and colors.
The length of the list must be as same as that of ssm_list, and
the order of labels in each list must be as same as those in ssm_list.}

\item{gemlabel_list}{NULL or a list of dataframes of sample (cell)
annotations and colors.
The length of the list must be as same as that of gem_list, and
the order of labels in each list must be as same as those in gem_list.}

\item{nrand_samples}{Number of samples (cells) used for random sampling.}

\item{show_row_names}{TRUE or FALSE: if TRUE, row names are shown.}

\item{title}{Title.}
}
\value{
A ComplexHeatmap object.
}
\description{
This function visualizes multivariate data by heatmaps.
}
\examples{
data(pbmcs_eg)
mat_CM <- SummarizedExperiment::assay(pbmcs_eg$CM, "counts")
mat_GO <- SummarizedExperiment::assay(pbmcs_eg$GO, "counts")
mat_KG <- SummarizedExperiment::assay(pbmcs_eg$KG, "counts")
ssm_list <- list(SSM_COMSig = mat_CM, SSM_GO = mat_GO, SSM_KEGG = mat_KG)
se <- SingleCellExperiment::altExp(pbmcs_eg$CM, "logcounts")
mat <- SummarizedExperiment::assay(se, "counts")
se <- SingleCellExperiment::altExp(pbmcs_eg$CM, "logcounts")
gem_list <- list(GeneExpr = SummarizedExperiment::assay(se, "counts"))
labels <- list() ; ssmlabel_list <- list()
for(i in seq_along(pbmcs_eg)){
  fa <- SummarizedExperiment::colData(pbmcs_eg[[i]])$seurat_clusters
  labels[[i]] <- data.frame(label = fa)
  colors <- rainbow(length(unique(labels[[i]]$label)))[labels[[i]]$label]
  labels[[i]]$color <- colors
  ssmlabel_list[[i]] <- labels[[i]]
}
names(ssmlabel_list) <- c("Label_COMSig", "Label_GO", "Label_KEGG")
phases <- SummarizedExperiment::colData(pbmcs_eg$CM)$Phase
label_CC <- data.frame(label = phases, color = NA)
gemlabel_list <- list(CellCycle = label_CC)
plot_multiheatmaps(ssm_list = ssm_list, gem_list = gem_list,
                   ssmlabel_list = ssmlabel_list,
                   gemlabel_list = gemlabel_list, nrand_samples = 50,
                   show_row_names = FALSE, title = "PBMC")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/find_marker_signs.R
\name{compute_sepI_clusters}
\alias{compute_sepI_clusters}
\title{Compute separation indices of sign scores for given two clusters.}
\usage{
compute_sepI_clusters(
  sce = NULL,
  labels = NULL,
  nrand_samples = NULL,
  ident_1 = NULL,
  ident_2 = NULL
)
}
\arguments{
\item{sce}{A SingleCellExperiment object.}

\item{labels}{A vector of labels of all the samples.}

\item{nrand_samples}{An integer for the number of samples used for
random sampling, which samples at least one sample per cluster.}

\item{ident_1}{Label names identifying cluster numbers,
e.g., ident_1 = 1, ident_1 = c(1, 3).}

\item{ident_2}{Label names identifying cluster numbers,
e.g., ident_2 = 2, ident_2 = c(2, 4).}
}
\value{
A SingleCellExperiment object.
}
\description{
This function computes separation indices of sign scores for given two
  clusters.
}
\examples{
data(pbmcs_eg)
labels <- SummarizedExperiment::colData(pbmcs_eg$GO)$seurat_clusters
pbmcs_eg$GO <- compute_sepI_clusters(sce = pbmcs_eg$GO, labels = labels,
                                     nrand_samples = 10, ident_1 = 1,
                                     ident_2 = c(0, 2))
# The results are stored in `metadata(pbmcs_eg$GO)$marker_signs`.

}
